
setwd("c:/Example2.1/")

data <- matrix(scan("ch20_cesd.txt"),ncol=1,byrow=T)

install.packages("mvtnorm")
library(mvtnorm)
require(EMMIX)

set.seed(216)
initobj <- init.mix(data, g=4, distr="mvn", ncov=3, nkmeans=10, nrandom=10, nhclust=F)
obj <- EMMIX(data, g=4, distr="mvn", ncov=3, clust=NULL, init=initobj, itmax=1000, epsilon=1e-8, debug=TRUE)

attributes(obj)
write.csv(cbind(obj$tau,obj$clust),"cluster_4gp.csv")

std <- bootstrap(data, n=3189, p=1, g=4, distr="mvn", ncov=3, popPAR=initobj, B=50, replace=TRUE, itmax=1000, epsilon=1e-6)
write.csv(std,"cluster_4gp_se.csv")

















