      integer n,nboot,addc,prest,number,sumfr,iter,mix,ch,ng,order(3)
      integer ind(15000)
      double precision tjdata(15000),tjtemp(15000),piest(5),muest(5)
      double precision alpest(5),pi(5),alpha(5),fct(5,6000)
      double precision piold(5),pi2old,ll,llold,alpold(5),muold(5)
      double precision sumpi1(5),ssqpi1(5),sumalp(5),ssqalp(5),summu(5)
      double precision ssqmu(5),mean(5),var(5),tempe
      double precision fitted,ttemp,ttemp1,ttem,chisq,devi    
      common/comm1/nc,group,tj,mu,tau,freq 
      integer nc,group,freq(6000)
      double precision tj(6000),mu(5),tau(5,6000)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand
      intrinsic abs,int,sqrt,log,exp

      open(21,file='gammadata.txt')

      read (21,*) n,nboot
      print *, 'Adopt single or mixed gamma? (0/1)'
      read *, mix
      if (mix.eq.1) print *, 'How many components?'
      read *, ng 
      do 50 j=1,n
	read (21,*) tjdata(j)
50    continue
      piest(ng)=1.  
      do 60 i=1,ng-1
        read (21,*) piest(i),alpest(i),muest(i)
        piest(ng)=piest(ng)-piest(i)
60    continue
      read (21,*) alpest(ng),muest(ng)
      write (25,*) 'piest: ', (piest(i),i=1,ng)    
      do 65 i=1,ng
        write (25,*) 'est: ', alpest(i),muest(i)
65    continue
      if (nboot.ne.1) then
	print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix, iy, iz
	print *, 'Do you want to print out the estimates '
	print *, '  for each bootstrap?     INPUT: 1(Yes); 0(No)'
        read *, prest
      endif
      do 68 i=1,ng
        sumpi1(i)=0.
        ssqpi1(i)=0.
68    continue
      do 70 m=1,ng
        sumalp(m)=0.
        ssqalp(m)=0.
        summu(m)=0.
        ssqmu(m)=0.
70    continue
      do 700 k=1,nboot
        if (nboot.ne.1) print *, 'k= ', k
75      do 80 l=1,5000
	  freq(l)=0
80      continue
        do 100 j=1,n
          if (nboot.eq.1) then
	    number=j
          else
	    rand=random()
            rand=1.+rand*float(n)
            number=int(rand)
          endif
	  tjtemp(j)=tjdata(number)
100     continue
c  group into classes
	nc=1
	j=1
	tj(1)=tjtemp(1)
120     addc=0
        do 140 l=1,nc
          if (tjtemp(j).eq.tj(l)) then
	    freq(l)=freq(l)+1
	    if (nboot.eq.1) ind(j)=l
	    goto 150
          endif
          if (l.eq.nc) addc=1
140     continue
150     if (addc.eq.1) then
	  nc=nc+addc
	  tj(nc)=tjtemp(j)
	  if (nboot.eq.1) ind(j)=nc
	  freq(nc)=1
        endif
	if (j.ne.n) then
	  j=j+1
	  goto 120
        endif
	sumfr=0
	do 160 l=1,nc
	  sumfr=sumfr+freq(l)
160     continue
        if (sumfr.ne.n) then
	  print *, 'Error: in the freq'
	  stop
	endif
        if (nboot.eq.1) then
	  do 180 l=1,nc
	    write (25,991) tj(l),freq(l) 
180       continue
	endif
	pi(ng)=1.
        do 185 i=1,ng-1
         pi(i)=piest(i)
         pi(ng)=pi(ng)-piest(i)
185     continue
        if (mix.eq.0) pi(1)=1.
        do 200 m=1,ng
          alpha(m)=alpest(m)
          mu(m)=muest(m)
          alpold(m)=alpha(m)
          muold(m)=mu(m)
200     continue
        call calpdf(ng,nc,alpha,mu,tj,fct)
        do 210 i=1,ng
          piold(i)=pi(i)
210     continue
        iter=1
300     call caltau(ng,nc,pi,fct,tau)
        call update(ng,n,nc,pi,tau,tj,freq,mu,alpha,group,mix,
     +	nboot,ifail)
c        if (ifail.ne.1.and.nboot.ne.1) goto 75
        if (nboot.ne.1) then
          do 302 ii=1,ng
            if (alpha(ii).gt.20.) goto 75
            if (alpha(ii).lt.0.1) goto 75
302       continue
        endif
        call calpdf(ng,nc,alpha,mu,tj,fct)
        call findll(ng,nc,pi,fct,freq,ll)
	if (nboot.eq.1) print *, 'iter= ',iter
        iter=iter+1
        if (nboot.eq.1) then
	  if (ll.lt.llold) write (3,*) 'decreasing ll:'
	  write (3,*) ll,ll-llold
	  llold=ll
        endif
	do 310 m=1,ng
	  write (4,*) m,abs(alpha(m)-alpold(m)),abs(mu(m)-muold(m))
	  if (abs(alpha(m)-alpold(m)).gt.0.00001.or.
     +	    abs(mu(m)-muold(m)).gt.0.00001) then
	    alpold(m)=alpha(m)
	    muold(m)=mu(m)
	    goto 300
	  endif
310     continue
c        if (iter.eq.300.and.nboot.ne.1) goto 75
	do 330 i=1,ng
        if (abs(piold(i)-pi(i)).gt.0.00001) then
	  do 320 m=1,ng
            piold(m)=pi(m)
320       continue
	  goto 300
        endif
330     continue
        ch=0 
        if (nboot.ne.1) ch=1
	if (ng.eq.2.and.mu(1).lt.mu(2)) ch=0
	if (ng.eq.3.and.mu(1).lt.mu(2).and.mu(2).lt.mu(3)) ch=0
	if (ng.eq.4.and.mu(1).lt.mu(2).and.mu(2).lt.mu(3).and.
     +     mu(3).lt.mu(4)) ch=0
c	if (alpha(1).lt.alpha(2).and.mu(1).lt.mu(2).and.nboot.ne.1) then
c	  print *, 'Estimates of pi(1), alp(1), mu(1), alp(2), mu(2)'
c	  print *, pi(1),alpha(1),mu(1),alpha(2),mu(2)
c	  print *, 'Need to change?  No (0) / Yes (1) / Delete (2)'        
c	  read *, ch
c        endif
c	if (alpha(1).gt.alpha(2).and.mu(1).gt.mu(2).and.nboot.ne.1) then
c	  print *, 'Estimates of pi(1), alp(1), mu(1), alp(2), mu(2)'
c	  print *, pi(1),alpha(1),mu(1),alpha(2),mu(2)
c	  print *, 'Need to change?  No (0) / Yes (1) / Delete (2)'        
c	  read *, ch
c        endif
c	if (ch.eq.2) goto 75
	if (ch.eq.1) then
          order(1)=1
          do 335 kk=2,ng
            if (mu(kk).lt.mu(order(1))) order(1)=kk
335       continue
          ind=1
          do 336 kk=1,ng
            if (order(1).ne.kk) then
              order(ind+1)=kk
              ind=ind+1
            endif
336       continue
	  if (mu(order(2)).gt.mu(order(3))) then
            kk=order(2)
            order(2)=order(3)
            order(3)=kk
          endif 
	  do 337 i=1,ng
	    piold(i)=pi(i)
	    alpold(i)=alpha(i)
	    muold(i)=mu(i)
337       continue
	  do 338 i=1,ng
	    pi(i)=piold(order(i))
	    alpha(i)=alpold(order(i))
	    mu(i)=muold(order(i))
338       continue
        endif
340	if (nboot.eq.1.or.prest.eq.1) then
          write (25,992) k,iter,ll
          write (25,*) 'Final pi: ', (pi(i),i=1,ng)
          do 380 i=1,ng
            write (25,*) 'Final est: ', i,alpha(i),mu(i)
380       continue
        endif
        do 390 i=1,ng
          sumpi1(i)=sumpi1(i)+pi(i)
          ssqpi1(i)=ssqpi1(i)+pi(i)*pi(i)
390     continue
        do 400 m=1,ng
	  sumalp(m)=sumalp(m)+alpha(m)
	  ssqalp(m)=ssqalp(m)+alpha(m)*alpha(m)
	  summu(m)=summu(m)+mu(m)
	  ssqmu(m)=ssqmu(m)+mu(m)*mu(m)
400     continue
700   continue
c      do 750 j=1,nc
c          write (25,*) tj(j),(tau(i,j),i=1,ng) 
c750   continue
      if (nboot.eq.1) then
c  use chisq.f
        chisq=0.
        devi=0.
        do 755 j=1,n
          fitted=0.
          do 752 i=1,ng
            fitted=fitted+tau(i,ind(j))*mu(i)
752       continue
          ttemp1=fitted*fitted
          ttemp=(tj(ind(j))-fitted)**2/ttemp1
          ttem=-log(tj(ind(j))/fitted)+(tj(ind(j))-fitted)/fitted
          chisq=chisq+ttemp   
          devi=devi+ttem   
          write (25,*) j,tj(ind(j)),(tau(i,ind(j)),i=1,ng)
c          write (25,*) j,tj(ind(j)),(tau(i,ind(j)),i=1,ng),fitted,
c     +      ttemp
755     continue
        write (25,*) 
        write (25,*) chisq,2*devi,n-ng+1-ng*2
      endif
      if (nboot.ne.1) then
	write (25,995) 
	do 760 i=1,ng  
	  mean(i)=sumpi1(i)/float(nboot)
	  var(i)=ssqpi1(i)/float(nboot)-mean(i)*mean(i)
	  write (25,*) 'pi: ', mean(i),sqrt(var(i))
760     continue
	do 780 m=1,ng
	  mean(m)=sumalp(m)/float(nboot)
	  var(m)=ssqalp(m)/float(nboot)-mean(m)*mean(m)
	  write (25,*) 'alpha: ', mean(m),sqrt(var(m))
780     continue
	do 800 m=1,ng
	  mean(m)=summu(m)/float(nboot)
	  var(m)=ssqmu(m)/float(nboot)-mean(m)*mean(m)
	  write (25,*) 'mu: ', mean(m),sqrt(var(m))
800     continue
      endif
980   format ('Initial estimates:',/2x,'pi(1)=',F9.4,'  pi(2)=',F9.4)
982   format (2x,'alpha(1)=',F9.5,'  mu(1)=',F15.3,/2x,'alpha(2)=',
     +  F9.4,'  mu(2)=',F15.3,/,'Total number of observations=',I5)
991   format (2x,'Data: ',F15.3,'; Frequency: ',I5)
992   format (/2x,'Bootstrap no. ',I5,
     +  ': After ',I4,' iterations, the log-likelihood is ',F11.3)
994   format (/,'Final estimates:',/2x,'pi(1)=',F9.4,'  pi(2)=',
     +  F9.4,/2x,'alpha(1)=',F9.5,'   mu(1)=',F15.3,
     +  /2x,'alpha(2)=',F9.5,'   mu(2)=',F15.3)
995   format (/,/,'RESULTS OF BOOTSTRAPPING:',/)
996   format (F15.3,' (',F15.3,')')
997   format (F15.3,' (',F15.3,')',5x,F15.3,' (',F15.3,')')
      stop
      end

      subroutine calpdf(ng,nc,alpha,mu,tj,fct)
      integer nc,ifail,ng
      double precision tj(6000),alpha(5),mu(5),gam(5),fct(5,6000)
      double precision temp
      real S14AAF
c      external S14AAF
      intrinsic exp,gamma    

      do 100 l=1,nc
	do 50 m=1,ng
	  gam(m)=gamma(alpha(m))
c	  gam(m)=S14AAF(alpha(m),ifail)
c	  if (ifail.ne.0) print *, 'ERROR in S14AAF'
	  temp=(alpha(m)/mu(m))**alpha(m)*tj(l)**(alpha(m)-1.)
	  fct(m,l)=temp*exp(-alpha(m)*tj(l)/mu(m))/gam(m)
50      continue
100   continue
      return
      end

      subroutine caltau(ng,nc,pi,fct,tau)
      integer nc,ng
      double precision pi(5),fct(5,6000),tau(5,6000),sumtemp

      do 100 l=1,nc
        sumtemp=0.    
        do 50 i=1,ng
          sumtemp=sumtemp+pi(i)*fct(i,l)
50      continue
	tau(ng,l)=1.
        do 80 i=1,ng-1
	  tau(i,l)=pi(i)*fct(i,l)/sumtemp
	  tau(ng,l)=tau(ng,l)-tau(i,l)
80      continue
100   continue
      return
      end

      subroutine update(ng,n,nc,pi,tau,tj,freq,mu,alpha,group,mix,
     +nboot,ifail)
      integer n,nc,freq(6000),group,mix,nboot,ng
      double precision pi(5),tau(5,6000),tj(6000),mu(5),alpha(5)
      double precision sumtau(5),sumttj(5),sumtj,sumtemp1,sumtemp2
      external evalfn,HYBRD1
      integer sizehy
      double precision x(1),xtol,fvec(1),work(100)

      pi(ng)=1.    
      sumtemp1=0.  
      sumtemp2=0.  
      do 200 i=1,ng-1
        sumtau(i)=0.
        sumttj(i)=0.
        sumtj=0.
        do 100 l=1,nc
	  sumtau(i)=sumtau(i)+tau(i,l)*freq(l)
	  sumttj(i)=sumttj(i)+tau(i,l)*tj(l)*freq(l)
	  sumtj=sumtj+tj(l)*freq(l)
100     continue
        pi(i)=sumtau(i)/float(n)
        pi(ng)=pi(ng)-pi(i)
        mu(i)=sumttj(i)/sumtau(i)
        sumtemp1=sumtemp1+sumttj(i)
        sumtemp2=sumtemp2+sumtau(i)
200   continue
      if (mix.eq.0) pi(1)=1.
c      mu(1)=sumttj/sumtau
      if (mix.eq.1) mu(ng)=(sumtj-sumtemp1)/(n-sumtemp2)
c      print *, pi(1), pi(2), n, ng
      do 400 group=1,ng
	ifail=0
	x(1)=alpha(group)
	xtol=0.00000000001
	sizehy=100
	call HYBRD1(evalfn,1,x,fvec,xtol,ifail,work,sizehy)
c	if (nboot.eq.1) print *, group, fvec(1)
	if (ifail.ne.1.and.nboot.eq.1.and.abs(fvec(1)).gt.1.) 
     +  print *, 'ifail= ',ifail
	if (ifail.ne.1.and.nboot.ne.1) return             
	alpha(group)=x(1)
	if (mix.eq.0) return
400   continue
      return
      end
      
      subroutine evalfn(num,x,fvec,iflag)
      integer num,iflag
      double precision x(*),fvec(*),tmp,tot,temp
      common/comm1/nc,group,tj,mu,tau,freq 
      integer nc,group,freq(6000)
      double precision tj(6000),mu(5),tau(5,6000)
      integer ifail,nn,nm
      real tmpr,w  
c      external S14ADF
      external psifn 
      intrinsic log

      tmp=x(1)
      nn=0
      nm=1
      tmpr=real(tmp)
      call psifn(tmpr,nn,1,nm,w,nz,ifail)
      if (ifail.ne.0) print *, 'ERROR in S14ADF'
      tot=0.  
      do 300 l=1,nc
        temp=1.+log(tmp*tj(l)/mu(group))-tj(l)/mu(group)
	tot=tot+(temp+dble(w))*tau(group,l)*freq(l)
300   continue
      fvec(1)=tot
      return
      end
      
      subroutine findll(ng,nc,pi,fct,freq,ll)
      integer nc,freq(6000),ng
      double precision pi(5),fct(5,6000),ll,sumtemp
      intrinsic log

      ll=0. 
      do 100 l=1,nc
        sumtemp=0.  
        do 50 i=1,ng
	  sumtemp=sumtemp+pi(i)*fct(i,l)
50      continue
	if (sumtemp.eq.0.) goto 100
	ll=ll+log(sumtemp)*freq(l)
100   continue
      return
      end
      
