      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer nboot,dtemp(maxng+1,max),iter,prest,ind,number
      double precision tjtemp(max),xjtemp(maxcov,max)
      double precision lamest(maxng),betest(maxng,maxcov)
      double precision gamest(maxng,maxcov),gamma(maxng,maxcov)
      double precision lambda(maxng),beta(maxng,maxcov)
      double precision lamold(maxng),betold(maxng,maxcov)
      double precision gamold(maxng,maxcov),mu(maxng,max)
      double precision xi(maxng,max),pi(maxng,max),s(maxng,max)
      double precision sumlam(maxng),ssqlam(maxng),ll,llold
      double precision sumgam(maxng,maxcov),ssqgam(maxng,maxcov)
      double precision sumbet(maxng,maxcov),ssqbet(maxng,maxcov)
      double precision mean(maxng,maxcov+1),var(maxng,maxcov+1)
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(maxng+1,max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand
      intrinsic exp,abs,int,sqrt 

      open (21,file='data.txt')
      open (25,file='output')

      read (21,*) n,ncov,ng,nboot
      do 100 j=1,n
        read (21,*) tjtemp(j),(xjtemp(l,j),l=2,ncov),
     +	(dtemp(i,j),i=1,ng)
        xjtemp(1,j)=1.
        dtemp(ng+1,j)=1
	do 50 i=1,ng
	  dtemp(ng+1,j)=dtemp(ng+1,j)-dtemp(i,j)
50      continue
100   continue
      do 150 i=1,ng
        read (21,*) lamest(i),(betest(i,l),l=1,ncov)
        write (25,*) lamest(i),(betest(i,l),l=1,ncov)
        if (i.eq.ng) goto 150
        read (21,*) (gamest(i,l),l=1,ncov)
        write (25,*) (gamest(i,l),l=1,ncov)
150   continue
      if (nboot.ne.1) then
	print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix,iy,iz
        print *, 'Do you want to print out the estimates '
        print *, '  for each bootstrap?    INPUT: 1(Yes); 0(No)'
	read *, prest
      endif
      write (25,999) n 
      do 180 i=1,ng-1
	sumlam(i)=0.
	ssqlam(i)=0.
	do 160 l=1,ncov
	  sumgam(i,l)=0.
	  ssqgam(i,l)=0.
	  sumbet(i,l)=0.
	  ssqbet(i,l)=0.
160     continue
180   continue
      do 200 l=1,ncov
	sumbet(ng,l)=0.
	ssqbet(ng,l)=0.
200   continue
      sumlam(ng)=0.
      ssqlam(ng)=0.
      do 800 k=1,nboot
	print *, 'k= ', k   
210   do 300 j=1,n
	if (nboot.eq.1) then
	  number=j
        else
	  rand=random()
	  if (j.le.149) then
	    rand=1.+rand*149.
	    number=int(rand)
	    goto 230
	  endif
	  if (j.gt.149.and.j.le.288) then
	    rand=1.+rand*139.
	    number=149+int(rand)
	    goto 230
	  endif
	  if (j.gt.288.and.j.le.344) then
	    rand=1.+rand*56.
	    number=288+int(rand)
	    goto 230
	  endif
	  rand=1.+rand*139.
          number=344+int(rand)
        endif
230     tj(j)=tjtemp(number)
	do 250 l=1,ncov
          xj(l,j)=xjtemp(l,number)
250     continue
	do 270 i=1,ng+1
          d(i,j)=dtemp(i,number)
270     continue
300   continue
      do 400 i=1,ng
        lambda(i)=lamest(i)
        lamold(i)=lamest(i)
	do 350 l=1,ncov
	  beta(i,l)=betest(i,l)
	  betold(i,l)=betest(i,l)
350     continue
	if (i.eq.ng) goto 400
	do 370 l=1,ncov
	  gamma(i,l)=gamest(i,l)
	  gamold(i,l)=gamest(i,l)
370     continue
400   continue
      do 500 j=1,n 
        do 440 i=1,ng
          mu(i,j)=0.
          do 420 l=1,ncov
            mu(i,j)=mu(i,j)+beta(i,l)*xj(l,j)
420       continue
          mu(i,j)=exp(mu(i,j))
440     continue
        sumxi=0.
        do 480 i=1,ng-1
          xi(i,j)=0.
          do 460 l=1,ncov
            xi(i,j)=xi(i,j)+gamma(i,l)*xj(l,j)
460       continue
          xi(i,j)=exp(xi(i,j))
	  sumxi=sumxi+xi(i,j)
480     continue
        pi(ng,j)=1.
        do 490 i=1,ng-1
	  pi(i,j)=xi(i,j)/(1.+sumxi)
	  pi(ng,j)=pi(ng,j)-pi(i,j)
490     continue
500   continue
      call cals(n,ng,tj,lambda,mu,s)
      iter=1
510   call caltau(n,ng,pi,s,tau)
      call update(gamma,beta,lambda,pi,mu,nboot,ifail)
      if (ifail.ne.1.and.nboot.ne.1) goto 210
      call cals(n,ng,tj,lambda,mu,s)
      call findll(n,ng,lambda,tj,mu,s,pi,d,ll)
c      write (25,*) 'll for iter ',iter,ll
      if (nboot.eq.1) print *, 'iter= ', iter
      iter=iter+1
      if (nboot.eq.1) then
	if (ll.lt.llold) write (3,*) 'decreasing ll:'
	write (3,*) ll,ll-llold
	llold=ll
      endif
      do 600 i=1,ng
	if (i.eq.ng) goto 550 
        do 530 l=1,ncov
          if (abs(gamold(i,l)-gamma(i,l)).gt.0.0001) goto 610
530     continue
550     do 570 l=1,ncov
          if (abs(betold(i,l)-beta(i,l)).gt.0.0001) goto 610
570     continue
        if (abs(lamold(i)-lambda(i)).gt.0.0001) goto 610
600   continue
      goto 720
610   do 700 i=1,ng
        if (i.eq.ng) goto 650
        do 630 l=1,ncov
	  gamold(i,l)=gamma(i,l)
630     continue
650     do 670 l=1,ncov
	  betold(i,l)=beta(i,l)
670     continue
        lamold(i)=lambda(i)
700   continue
      goto 510
720   if (nboot.eq.1.or.prest.eq.1) then
	write (25,990) k,iter,ll
	do 730 i=1,ng-1
	  write (25,991) i
	  write (25,992) (gamma(i,l),l=1,ncov)
	  write (25,993) lambda(i)
	  write (25,994) (beta(i,l),l=1,ncov)
730     continue
	write (25,991) ng
	write (25,993) lambda(ng)
	write (25,994) (beta(ng,l),l=1,ncov)
      endif
      do 760 i=1,ng-1
	sumlam(i)=sumlam(i)+lambda(i)
	ssqlam(i)=ssqlam(i)+lambda(i)*lambda(i)
	do 740 l=1,ncov
	  sumgam(i,l)=sumgam(i,l)+gamma(i,l)
	  ssqgam(i,l)=ssqgam(i,l)+gamma(i,l)*gamma(i,l)
	  sumbet(i,l)=sumbet(i,l)+beta(i,l)
	  ssqbet(i,l)=ssqbet(i,l)+beta(i,l)*beta(i,l)
740     continue
760   continue
      sumlam(ng)=sumlam(ng)+lambda(ng)
      ssqlam(ng)=ssqlam(ng)+lambda(ng)*lambda(ng)
      do 780 l=1,ncov
	sumbet(ng,l)=sumbet(ng,l)+beta(ng,l)
	ssqbet(ng,l)=ssqbet(ng,l)+beta(ng,l)*beta(ng,l)
780   continue
800   continue
      if (nboot.ne.1) then
	write (25,995)
	do 820 i=1,ng-1
          do 810 l=1,ncov
            mean(i,l)=sumgam(i,l)/float(nboot)
	    var(i,l)=ssqgam(i,l)/float(nboot)-mean(i,l)*mean(i,l)
810       continue
          write (25,996) i,(mean(i,l),l=1,ncov)
          write (25,997) i,(sqrt(var(i,l)),l=1,ncov)
820     continue
	write (25,998)
	do 840 i=1,ng
          mean(i,1)=sumlam(i)/float(nboot)
	  var(i,1)=ssqlam(i)/float(nboot)-mean(i,1)*mean(i,1)
          do 830 l=1,ncov
           mean(i,l+1)=sumbet(i,l)/float(nboot)
	   var(i,l+1)=ssqbet(i,l)/float(nboot)-mean(i,l+1)*mean(i,l+1)
830       continue
          write (25,996) i,(mean(i,l),l=1,ncov+1)
          write (25,997) i,(sqrt(var(i,l)),l=1,ncov+1)
840     continue
      endif
990   format('Bootstrap: ',I3,'   No of iteration: ',I5,
     +  '   Log-likelihood: ',F15.5)
991   format('Estimates for Group ',I2)
992   format(2X,'Gamma: ',20F9.5)
993   format(2X,'Lambda: ',F9.5)
994   format(2X,'Beta: ',20F9.5)
995   format(/,'Bootstrap result for Gamma:')
996   format(2X,'Mean: ',I3,21F9.5)
997   format(2X,'S.E.: ',I3,21F9.5)
998   format(/,'Bootstrap result for Lambda, Beta:')
999   format(/,'No. of observations:',I6)
      stop
      end

      subroutine cals(n,ng,tj,lambda,mu,s)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng
      double precision tj(max),lambda(maxng),mu(maxng,max)
      double precision s(maxng,max)
      intrinsic exp

      do 200 i=1,ng
        do 100 j=1,n
          s(i,j)=exp(-tj(j)**(lambda(i))*mu(i,j))
100     continue
200   continue
      return
      end

      subroutine caltau(n,ng,pi,s,tau)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng
      double precision pi(maxng,max),s(maxng,max),tau(maxng,max)
      double precision temp

      do 100 j=1,n
	temp=0.
	tau(ng,j)=1.
	do 50 i=1,ng
	  temp=temp+pi(i,j)*s(i,j)
50      continue
	do 70 i=1,ng-1
          tau(i,j)=pi(i,j)*s(i,j)/temp
          tau(ng,j)=tau(ng,j)-tau(i,j)
70      continue
100   continue
      return
      end

      subroutine update(gamma,beta,lambda,pi,mu,nboot,ifail)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ind,ne,nboot
      double precision gamma(maxng,maxcov),xi(maxng,max),sumxi
      double precision pi(maxng,max),beta(maxng,maxcov)
      double precision lambda(maxng),mu(maxng,max)
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(maxng+1,max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      intrinsic exp
      external evalfn,evalfg,HYBRD1
      integer sizehy,ifail
      double precision x((maxng-1)*maxcov),xtol
      double precision fvec((maxng-1)*maxcov),work(3000)

      ind=1
      do 200 i=1,ng-1
        do 100 l=1,ncov
          x(ind)=gamma(i,l)
          ind=ind+1
100     continue
200   continue
      ifail=0
      ne=(ng-1)*ncov
      xtol=0.000000001
      sizehy=3000
      call HYBRD1(evalfg,ne,x,fvec,xtol,ifail,work,sizehy)
c      if (nboot.eq.1) print *, 'gamma: ',(fvec(l),l=1,ne)
      if (ifail.ne.1.and.nboot.eq.1) print *, 'ifail= ',ifail
      if (ifail.ne.1.and.nboot.ne.1) return
      ind=1
      do 300 i=1,ng-1
        do 250 l=1,ncov
          gamma(i,l)=x(ind)
          ind=ind+1
250     continue
300   continue
      do 400 j=1,n 
        sumxi=0.
        do 350 i=1,ng-1
          xi(i,j)=0.
          do 320 l=1,ncov
            xi(i,j)=xi(i,j)+gamma(i,l)*xj(l,j)
320       continue
          xi(i,j)=exp(xi(i,j))
	  sumxi=sumxi+xi(i,j)
350     continue
        pi(ng,j)=1.
        do 370 i=1,ng-1
	  pi(i,j)=xi(i,j)/(1.+sumxi)
	  pi(ng,j)=pi(ng,j)-pi(i,j)
370     continue
400   continue
      do 700 group=1,ng
        ifail=0
        do 500 l=1,ncov
          x(l)=beta(group,l)
500     continue
        x(ncov+1)=lambda(group)
        xtol=0.000000001
	ne=ncov+1
        call HYBRD1(evalfn,ne,x,fvec,xtol,ifail,work,sizehy)
c        if (nboot.eq.1) print *,'Group: ',group,(fvec(l),l=1,ne)
        if (ifail.ne.1.and.nboot.eq.1) print *, 'ifail= ',ifail
        if (ifail.ne.1.and.nboot.ne.1) return
        do 600 l=1,ncov
          beta(group,l)=x(l)
600     continue
        do 650 j=1,n
          mu(group,j)=0.
          do 620 l=1,ncov
            mu(group,j)=mu(group,j)+beta(group,l)*xj(l,j)
620       continue
          mu(group,j)=exp(mu(group,j))
650     continue
        lambda(group)=x(ncov+1)
700   continue
      return
      end

      subroutine evalfg(ne,x,fvec,iflag)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ne,iflag,ind
      double precision x(*),fvec(*),tmp(maxng,maxcov)
      double precision tot(maxcov+1),temp,sumxi,xi(maxng)
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(maxng+1,max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      intrinsic exp

      ind=1
      do 150 i=1,ng-1
        do 100 l=1,ncov
          tmp(i,l)=x(ind)
          fvec(ind)=0.
          ind=ind+1
100     continue
150   continue
      do 500 j=1,n
        sumxi=0.
	do 250 i=1,ng-1
	  xi(i)=0.
          do 200 l=1,ncov
            xi(i)=xi(i)+tmp(i,l)*xj(l,j)
200       continue
          xi(i)=exp(xi(i))
          sumxi=sumxi+xi(i)
250     continue
        do 400 i=1,ng-1
          do 350 l=1,ncov
	    temp=d(i,j)+d(ng+1,j)*tau(i,j)-xi(i)/(1.+sumxi)
            fvec((i-1)*ncov+l)=fvec((i-1)*ncov+l)+temp*xj(l,j)
350       continue
400     continue
500   continue
      return
      end
      
      subroutine evalfn(ne,x,fvec,iflag)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ne,iflag
      double precision x(*),fvec(*),tmp(maxcov+1)
      double precision tot(maxcov+1),temp,eta,logs
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(maxng+1,max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=x(l)
        fvec(l)=0.
50    continue
      do 300 j=1,n
        if (tj(j).eq.0.) tj(j)=.000001/12.
        eta=0.
        do 100 l=1,ncov
          eta=eta+tmp(l)*xj(l,j)
100     continue
        logs=-tj(j)**(tmp(ncov+1))*exp(eta)
	temp=(d(group,j)+d(ng+1,j)*tau(group,j))*logs
        do 200 l=1,ncov
          fvec(l)=fvec(l)+(d(group,j)+temp)*xj(l,j)
200     continue
	temp=temp*log(tj(j))+d(group,j)*(1./tmp(ncov+1)+log(tj(j)))
        fvec(ncov+1)=fvec(ncov+1)+temp
300   continue
      return
      end
      
      subroutine findll(n,ng,lambda,tj,mu,s,pi,d,ll)
      integer max,maxng,maxcov
      parameter(max=5000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng,d(maxng+1,max)
      double precision lambda(maxng),tj(max),mu(maxng,max)
      double precision s(maxng,max),pi(maxng,max)
      double precision ll,surv,f(maxng)
      intrinsic log

      ll=0. 
      do 100 j=1,n
        if (tj(j).eq.0.) tj(j)=.000001/12.
	surv=0.
	do 50 i=1,ng
	  f(i)=lambda(i)*tj(j)**(lambda(i)-1.)*mu(i,j)*s(i,j)
	  surv=surv+pi(i,j)*s(i,j)
	  ll=ll+d(i,j)*log(pi(i,j)*f(i))
50      continue
	ll=ll+d(ng+1,j)*log(surv)
100   continue
      return
      end
      
