      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer nboot,delcol,col(20),dtemp(maxng+1,max),prest,number,ch
      integer iter,ind,done(max),next,nj,finish
      integer ind1(20),ownest,comb,numpub,dummy,iw(max,maxng+1)
      double precision betest(maxng,maxcov)
      double precision tjtemp(max),xjtemp(max,maxcov)
      double precision beta(maxng,maxcov),fct(maxng,max),xi(maxng)
      double precision betold(maxng,maxcov),gamest(maxng,maxcov+1)
      double precision gamma(maxng,maxcov+1),gamold(maxng,maxcov+1)
      double precision sumgam(maxng,maxcov+1),ssqgam(maxng,maxcov+1)
      double precision sumbet(maxng,maxcov),ssqbet(maxng,maxcov)
      double precision mean(maxng,maxcov+1),var(maxng,maxcov+1)
      double precision w(max,maxcov+1),tmp(maxng),ll
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      common/cdata/wsort,iwsort
      integer iwsort(max,maxng+1)
      double precision wsort(max,maxcov+1)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand
      intrinsic abs,int,sqrt 

      open(20,file='data_semi.txt')
      open(21,file='initials_semi.txt')
      open(25,file='output')

      read (21,*) n,ncov,ng,nboot
      do 5 j=1,n
        read (20,*) tjtemp(j),(xjtemp(j,l),l=1,ncov),
     +  (dtemp(i,j),i=1,ng)
	dtemp(ng+1,j)=1
	do 3 i=1,ng
	  dtemp(ng+1,j)=dtemp(ng+1,j)-dtemp(i,j)
3       continue
5     continue
      ncov=ncov-delcol
      ownest=1
      if (ownest.eq.0) then
	stop
      else 
	do 8 i=1,ng
          read (21,*) (betest(i,l),l=1,ncov)
          write (25,*) (betest(i,l),l=1,ncov)
          if (i.eq.ng) goto 8
          read (21,*) (gamest(i,l),l=1,ncov+1)
          write (25,*) (gamest(i,l),l=1,ncov+1)
8       continue
      endif
      if (nboot.ne.1) then
	print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix,iy,iz
        print *, 'Do you want to print out the estimates '
        print *, '  for each bootstrap?    INPUT: 1(Yes); 0(No)'
	read *, prest
      endif
      write (25,999) n 
      do 20 i=1,ng-1
	do 10 l=1,ncov
	  sumbet(i,l)=0.
	  ssqbet(i,l)=0.
	  sumgam(i,l)=0.
	  ssqgam(i,l)=0.
10      continue
	  sumgam(i,ncov+1)=0.
	  ssqgam(i,ncov+1)=0.
20    continue
      do 23 l=1,ncov
	sumbet(ng,l)=0.
	ssqbet(ng,l)=0.
23    continue
      do 800 k=1,nboot
       print *, 'k= ', k   
30     do 100 j=1,n
	if (nboot.eq.1) then
	  number=j
        else
	  rand=random()
	  if (j.le.149) then
	    rand=1.+rand*149.
	    number=int(rand)
	    goto 33
	  endif
	  if (j.gt.149.and.j.le.288) then
	    rand=1.+rand*139.
	    number=149+int(rand)
	    goto 33
	  endif
	  if (j.gt.288.and.j.le.344) then
	    rand=1.+rand*56.
	    number=288+int(rand)
	    goto 33
	  endif
	  rand=1.+rand*139.
	  number=344+int(rand)
        endif
33      w(j,1)=tjtemp(number)
	do 50 l=1,ncov
          w(j,l+1)=xjtemp(number,l)
50      continue
	do 70 i=1,ng+1
          iw(j,i)=dtemp(i,number)
70      continue
100   continue
      call sort(n,ncov+1,ng,nboot,w,iw)
      do 115 j=1,n 
        tj(j)=wsort(j,1)
	do 105 l=1,ncov
          xj(j,l)=wsort(j,l+1)
105     continue
	do 110 i=1,ng+1
          delta(i,j)=iwsort(j,i)
110     continue
115   continue
      do 150 i=1,ng
	do 120 l=1,ncov
	  beta(i,l)=betest(i,l)
	  betold(i,l)=betest(i,l)
120     continue
	if (i.eq.ng) goto 150
	do 140 l=1,ncov+1
          gamma(i,l)=gamest(i,l)
          gamold(i,l)=gamest(i,l)
140     continue
150   continue
      do 400 j=1,n
	do 300 i=1,ng
	  eta(i,j)=0.
	  do 200 l=1,ncov
	    eta(i,j)=eta(i,j)+beta(i,l)*xj(j,l)
200       continue
	  eta(i,j)=exp(eta(i,j))
300     continue
	sumxi=0.
	do 320 i=1,ng-1
	  xi(i)=gamma(i,1)
	  do 310 l=1,ncov
  	    xi(i)=xi(i)+gamma(i,l+1)*xj(j,l)
310       continue
	  xi(i)=exp(xi(i))
	  sumxi=sumxi+xi(i)
320     continue
	pi(ng,j)=1.
	do 350 i=1,ng-1
	  pi(i,j)=xi(i)/(1.+sumxi)
	  pi(ng,j)=pi(ng,j)-pi(i,j)
350     continue
	done(j)=0 
400   continue
c   obtain dj(j) using kmrisk1.f (without covariate)
      do 430 j=1,n
        if (done(j).eq.1.or.delta(ng+1,j).eq.1) goto 430
	dj(j)=1
        next=j+1
425     if (tj(j).eq.tj(next)) then
	  done(next)=1
	  if (delta(ng+1,next).ne.1) dj(j)=dj(j)+1
        else 
	  goto 430
        endif
	if (next.lt.n) then
	  next=next+1
	  goto 425
        endif
430   continue
      do 433 i=1,ng
        tmp(i)=1.
433   continue
      do 435 j=1,n
        done(j)=0
435   continue
      do 450 j=1,n
	if (delta(ng+1,j).eq.1) then
	  do 436 i=1,ng
	    s0(i,j)=s0(i,j-1)
436       continue
	  goto 450
	endif
        if (done(j).eq.1) goto 450
	nj=n-j+1
        do 437 i=1,ng
	  if (delta(i,j).eq.1) then
	    tmp(i)=tmp(i)*float(nj-dj(j))/float(nj)
	    goto 438
          endif
437     continue
438     do 439 i=1,ng
	  s0(i,j)=tmp(i)
439     continue
        if (dj(j).gt.1) then
          do 445 kk=1,dj(j)-1
	    done(j+kk)=1
	    do 442 i=1,ng
	      s0(i,j+kk)=s0(i,j)
442         continue
445       continue
	endif
450   continue
      iter=1
      finish=0
500   call caltau(iter)
      call calcs0(finish)
      call update(beta,gamma,nboot,ifail)
      if (ifail.ne.1.and.nboot.ne.1) then
	write (25,*) 'ifail= ',ifail,k,iter
	goto 30
      endif
      if (nboot.eq.1) then
	call findll(ll)
c        write (25,*) 'll for iter ',iter,ll
      endif
      if (nboot.eq.1) print *, 'iter= ', iter
      iter=iter+1
      if (iter.eq.100.and.nboot.ne.1) then
	goto 30
      endif
      do 550 i=1,ng
        if (i.eq.ng) goto 520
        do 510 l=1,ncov+1
          if (abs((gamold(i,l)-gamma(i,l))/gamma(i,l)).gt.0.001) 
     +	  goto 551
510     continue
520     do 530 l=1,ncov
          if (abs((betold(i,l)-beta(i,l))/beta(i,l)).gt.0.001) 
     +	  goto 551
530     continue
550   continue
      goto 599
551   do 580 i=1,ng
	if (i.eq.ng) goto 570
        do 560 l=1,ncov+1
	  gamold(i,l)=gamma(i,l)
560     continue
570     do 575 l=1,ncov
	  betold(i,l)=beta(i,l)
575     continue
580   continue
      goto 500
599   if (ifail.ne.1.and.nboot.ne.1) then
	write (25,*) 'ifail= ',ifail,k
	goto 30
      endif   
      finish=1
      call calcs0(finish)
      if (nboot.eq.1.or.prest.eq.1) then
	write (25,990) k,iter,ll
	do 730 i=1,ng-1
	  write (25,991) i
	  write (25,992) (gamma(i,l),l=1,ncov+1)
	  write (25,994) (beta(i,l),l=1,ncov)
730     continue
	write (25,991) ng
	write (25,994) (beta(ng,l),l=1,ncov)
      endif
      do 760 i=1,ng-1
	do 740 l=1,ncov
	  sumgam(i,l)=sumgam(i,l)+gamma(i,l)
	  ssqgam(i,l)=ssqgam(i,l)+gamma(i,l)*gamma(i,l)
	  sumbet(i,l)=sumbet(i,l)+beta(i,l)
	  ssqbet(i,l)=ssqbet(i,l)+beta(i,l)*beta(i,l)
740     continue
	sumgam(i,ncov+1)=sumgam(i,ncov+1)+gamma(i,ncov+1)
	ssqgam(i,ncov+1)=ssqgam(i,ncov+1)+gamma(i,ncov+1)**2
760   continue
      do 780 l=1,ncov
	sumbet(ng,l)=sumbet(ng,l)+beta(ng,l)
	ssqbet(ng,l)=ssqbet(ng,l)+beta(ng,l)*beta(ng,l)
780   continue
800   continue
      if (nboot.ne.1) then
	write (25,995)
	do 820 i=1,ng-1
	  do 810 l=1,ncov+1
	    mean(i,l)=sumgam(i,l)/float(nboot)
	    var(i,l)=ssqgam(i,l)/float(nboot)-mean(i,l)*mean(i,l)
810       continue
	  write (25,996) i,(mean(i,l),l=1,ncov+1)
	  write (25,997) i,(sqrt(var(i,l)),l=1,ncov+1)
820     continue
	write (25,998)
	do 840 i=1,ng
	  do 830 l=1,ncov
	    mean(i,l)=sumbet(i,l)/float(nboot)
	    var(i,l)=ssqbet(i,l)/float(nboot)-mean(i,l)*mean(i,l)
830       continue
	  write (25,996) i,(mean(i,l),l=1,ncov)
	  write (25,997) i,(sqrt(var(i,l)),l=1,ncov)
840     continue
      endif
990   format('Bootstrap: ',I3,'   No of iteration: ',I5,
     +  '   Log-likelihood: ',F15.5)
991   format('Estimates for Group ',I2)
992   format(2X,'Gamma: ',20F9.5)
994   format(2X,'Beta: ',20F9.5)
995   format(/,'Bootstrap result for Gamma: ')
996   format(2X,'Mean: ',I3,21F9.5)
997   format(2X,'S.E.: ',I3,21F9.5)
998   format(/,'Bootstrap result for Beta: ')
999   format(/,'No. of observations:',I6)
      stop
      end

      subroutine calcs0(finish)
      integer max,maxng,maxcov,iter
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ctr,done(max),finish
      double precision sumh(maxng),h0(max),srisk1,temp,tmp(maxng)
      double precision ratio
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      common/comma/cumh,h
      double precision cumh(maxng,max),h(maxng,max)
      intrinsic exp

      do 105 i=1,ng
        sumh(i)=0.
	do 101 j=1,n
	  cumh(i,j)=0.
101     continue
105   continue
      do 200 j=1,n
        done(j)=0
200   continue
      do 450 j=1,n
	if (delta(ng+1,j).eq.1) then
	  do 250 i=1,ng
	    s0(i,j)=s0(i,j-1)
	    cumh(i,j)=cumh(i,j-1)
250       continue
          goto 450
	endif
        if (done(j).eq.1) goto 450
        do 270 i=1,ng
	  tmp(i)=0.
270     continue
	do 300 k=j,n
	  do 280 i=1,ng
	    temp=delta(i,k)+delta(ng+1,k)*tau(i,k)
	    tmp(i)=tmp(i)+temp*eta(i,k)
280       continue
300     continue
	do 350 i=1,ng
	  if (delta(i,j).eq.1) then
	    sumh(i)=sumh(i)+dj(j)/tmp(i)
	    cumh(i,j)=sumh(i)
	    goto 360
	  endif
350     continue
360	do 380 i=1,ng
	  s0(i,j)=exp(-sumh(i))
380     continue
        if (dj(j).gt.1) then
          do 440 ii=1,dj(j)-1
	    done(j+ii)=1
	    do 420 i=1,ng
	      s0(i,j+ii)=s0(i,j)
	      cumh(i,j+ii)=cumh(i,j)
420         continue
440       continue
	endif
450   continue
      if (finish.ne.1) return
      do 500 i=1,ng
	ctr=1
	do 490 j=1,n
	  if (delta(i,j).eq.1) then
	    ctr=j
	    goto 490
	  endif
	  do 470 k=j,n
	    if (delta(i,k).ne.1) goto 470
	    ratio=(tj(j)-tj(ctr))/(tj(k)-tj(ctr))
	    temp=-log(s0(i,j))+log(s0(i,ctr)/s0(i,k))*ratio
	    s0(i,j)=exp(-temp)
	    goto 490
470       continue
490     continue
500   continue
501   do 505 j=1,n
	ctr=1*delta(1,j)+2*delta(2,j)+3*delta(3,j)
c	write (25,*) tj(j),s0(1,j)
505   continue
      if (finish.eq.1) return  
      if (finish.eq.1) then
	write (26,*) 0.,1.
	write (26,*) tj(1),1.
	write (27,*) 0.,1.
	write (27,*) tj(1),1.
	do 860 j=1,n-1
	  write (26,*) tj(j),s0(1,j)
	  write (26,*) tj(j+1),s0(1,j)
	  write (27,*) tj(j),s0(2,j)
	  write (27,*) tj(j+1),s0(2,j)
860     continue
	write (26,*) tj(n),s0(1,n)
	write (27,*) tj(n),s0(2,n)
      endif   
      goto 600
	ctr=1
100	  if (delta(i,ctr).ne.1) then
	    ctr=ctr+dj(ctr)
	    if (delta(3,ctr).eq.1) ctr=ctr+1
	    goto 400
          endif
	  h0(ctr)=0.
	  srisk1=0.
	  do 150 k=ctr,n
	    temp=delta(i,k)+delta(3,k)*tau(i,k)
	    srisk1=srisk1+temp*eta(i,k)
150       continue
          h0(ctr)=dj(ctr)/srisk1
          ind=delta(1,ctr)+2*delta(2,ctr)
	  print *,ctr,ind,dj(ctr),h0(ctr),s0(1,ctr),s0(2,ctr)
          ctr=ctr+dj(ctr)
400   if (ctr.le.n) goto 100
600   continue
      return
      end

      subroutine caltau(iter)
      integer max,maxng,maxcov,iter
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      double precision tmp
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)

      if (iter.eq.1) goto 200
      do 100 j=1,n
	tmp=0.
	do 50 i=1,ng
	  tau(i,j)=pi(i,j)*s0(i,j)**eta(i,j)
	  tmp=tmp+tau(i,j)
50      continue
	do 80 i=1,ng
	  tau(i,j)=tau(i,j)/tmp
80      continue
100   continue
      return
200   do 300 j=1,n
	do 250 i=1,ng
	  tau(i,j)=pi(i,j)
250   continue
300   continue
      return
      end

      subroutine update(beta,gamma,nboot,ifail)
      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer nboot,num,ind
      double precision beta(maxng,maxcov),sumtau,sumxi,xi(maxng)
      double precision gamma(maxng,maxcov+1)
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      external evalfb,evalfg,HYBRD1
      integer sizehy,ifail
      double precision x((maxng-1)*(maxcov+1)),xtol
      double precision fvec((maxng-1)*(maxcov+1)),work(3000)

c   update gamma of the logistic model
      ind=1
      do 120 i=1,ng-1
	do 100 l=1,ncov+1
	  x(ind)=gamma(i,l)
	  ind=ind+1
100     continue
120   continue
      ifail=0
      xtol=0.000000001
      sizehy=3000
      num=(ng-1)*(ncov+1)
      call HYBRD1(evalfg,num,x,fvec,xtol,ifail,work,sizehy)
c      if (nboot.eq.1) print *, 'fvec for gamma: ', (fvec(l),l=1,num)
      if (ifail.ne.1.and.nboot.eq.1) print *, 'ifail= ',ifail
      if (ifail.ne.1.and.nboot.ne.1) then
	do 125 l=1,num
	  if (abs(fvec(l)).gt.0.0001) then
	    ifail=2
	    return
	  endif
125     continue
      endif
      ind=1
      do 150 i=1,ng-1  
        do 130 l=1,ncov+1
          gamma(i,l)=x(ind)
	  ind=ind+1
130     continue
150   continue
      do 180 j=1,n
	sumxi=0.
        do 170 i=1,ng-1
	  xi(i)=gamma(i,1)
          do 160 l=1,ncov
            xi(i)=xi(i)+gamma(i,l+1)*xj(j,l)
160       continue
	  xi(i)=exp(xi(i))
	  sumxi=sumxi+xi(i)
170     continue
	pi(ng,j)=1.
	do 175 i=1,ng-1
          pi(i,j)=xi(i)/(1.+sumxi)
          pi(ng,j)=pi(ng,j)-pi(i,j)
175     continue
180   continue
c   update beta_i of the component regression model
191   do 400 group=1,ng
        ifail=0
        do 200 l=1,ncov
          x(l)=beta(group,l)
200     continue
        xtol=0.000000001
        call HYBRD1(evalfb,ncov,x,fvec,xtol,ifail,work,sizehy)
c        if (nboot.eq.1) print *, 'fvec for beta: ',group,
c     +	(fvec(l),l=1,ncov)
        if (ifail.ne.1.and.nboot.eq.1) print *, 'ifail= ',ifail
      if (ifail.ne.1.and.nboot.ne.1) then
	do 225 l=1,ncov
	  if (abs(fvec(l)).gt.0.0001) then
	    ifail=2
	    return
	  endif
225     continue
      endif
        do 300 l=1,ncov
          beta(group,l)=x(l)
300     continue
        do 350 j=1,n   
          eta(group,j)=0.
	  do 320 l=1,ncov 
	    eta(group,j)=eta(group,j)+beta(group,l)*xj(j,l)
320       continue
          eta(group,j)=exp(eta(group,j))
350     continue
400   continue
      return
      end

      subroutine evalfg(ne,x,fvec,iflag)
      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ne,iflag,ind
      double precision x(*),fvec(*),tmp(maxng,maxcov+1),sumxi
      double precision tot(maxcov+1),temp,temp1,te,xi(maxng)
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      integer ifail,nn,nm
      intrinsic exp,log

      ind=1
      do 80 i=1,ng-1
        do 50 l=1,ncov+1
          tmp(i,l)=x(ind)
          fvec(ind)=0.
          ind=ind+1  
50      continue
80    continue
      do 300 j=1,n
        sumxi=0.
	do 140 i=1,ng-1
          xi(i)=tmp(i,1)
          do 100 l=1,ncov
            xi(i)=xi(i)+tmp(i,l+1)*xj(j,l)
100       continue
          xi(i)=exp(xi(i))
	  sumxi=sumxi+xi(i)
140     continue
        do 250 i=1,ng-1
	 temp=delta(i,j)+delta(ng+1,j)*tau(i,j)
	 temp=temp-xi(i)/(1.+sumxi)
         fvec((i-1)*(ncov+1)+1)=fvec((i-1)*(ncov+1)+1)+temp
         do 200 l=2,ncov+1
          fvec((i-1)*(ncov+1)+l)=fvec((i-1)*(ncov+1)+l)+temp*xj(j,l-1)
200      continue
250     continue
300   continue
      return
      end

      subroutine evalfb(ne,x,fvec,iflag)
      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ne,iflag,ctr
      double precision x(*),fvec(*),tmp(maxcov+1),srisk2(maxcov)
      double precision tot(maxcov+1),temp,temp1,te,etatmp
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      common/comma/cumh,h
      double precision cumh(maxng,max),h(maxng,max)
      integer ifail,nn,nm
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=x(l)
        fvec(l)=0.
50    continue
      ctr=1
      do 300 j=1,n
	  etatmp=0.
	  do 120 l=1,ncov
            etatmp=etatmp+tmp(l)*xj(j,l)
120       continue
          etatmp=exp(etatmp) 
	  temp=delta(group,j)+delta(ng+1,j)*tau(group,j)
          do 200 l=1,ncov
            fvec(l)=fvec(l)+xj(j,l)*(delta(group,j)
     +	    +temp*log(s0(group,j))*etatmp)
200       continue
        ctr=ctr+dj(j)
300   continue
      return
      end
      
      subroutine sort(n,nv,ng,nboot,w,iw)
      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,nv,ng,point(max),count,iw(max,maxng+1),nboot
      double precision w(max,maxcov+1)
      intrinsic nint
      common/cdata/wsort,iwsort
      integer iwsort(max,maxng+1)
      double precision wsort(max,maxcov+1)

      point(1)=1
      count=1      
50    if (count.eq.n) goto 200
      point(count+1)=count+1
      do 100 k=count,1,-1
	if (w(count+1,1).lt.w(point(k),1)) then
	  point(k+1)=point(k)
	  point(k)=count+1 
	  goto 100
        endif
c        if (w(count+1,1).eq.w(point(k),1).and.nboot.eq.1) 
c     +	print *,'tie:',w(point(k),1)
        goto 150
100   continue
150   count=count+1
      goto 50
200   do 300 j=1,n 
        do 220 l=1,nv
          wsort(j,l)=w(point(j),l)
220     continue
	if (j.ne.1) then
	 if (wsort(j,1).le.wsort(j-1,1)) wsort(j,1)=wsort(j-1,1)+.000001
	endif
        do 250 l=1,ng+1
          iwsort(j,l)=iw(point(j),l)
250     continue
c        if (nboot.eq.1)
c     +	write (25,*) (wsort(j,l),l=1,nv),(iwsort(j,l),l=1,ng)
300   continue
      return
      end
      
      subroutine findll(ll)
      integer max,maxng,maxcov
      parameter(max=1000)
      parameter(maxng=3)
      parameter(maxcov=20)
      double precision ll,surv,f(maxng)
      common/comm1/s0,pi,eta,tau,delta,dj,n,ng,ncov
      integer delta(maxng+1,max),dj(max),n,ng,ncov
      double precision pi(maxng,max),s0(maxng,max),eta(maxng,max)
      double precision tau(maxng,max)
      common/comm2/xj,tj,group
      integer group
      double precision xj(max,maxcov),tj(max)
      intrinsic log

      ll=0.
      do 100 j=1,n
	surv=0.
	do 50 i=1,ng
	  if (j.eq.1) then
	    f(i)=(-1.*log(s0(i,j)))*eta(i,j)*s0(i,j)**eta(i,j)
	  else
	    f(i)=(log(s0(i,j-1)/s0(i,j)))*eta(i,j)*s0(i,j)**eta(i,j)
	    f(i)=f(i)/(tj(j)-tj(j-1))
	  endif
	  surv=surv+pi(i,j)*s0(i,j)**eta(i,j)
	  if (f(i).eq.0.) goto 50
	  ll=ll+delta(i,j)*log(pi(i,j)*f(i))
50      continue
        ll=ll+delta(ng+1,j)*log(surv)
100   continue
      return
      end
      

