      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer nboot,dtemp(max),iter,prest,ind,number,maxit
      double precision tjtemp(max),xjtemp(maxcov,max),a2(10)
      double precision lamest(maxng),betest(maxng,maxcov)
      double precision lambda(maxng),beta(maxng,maxcov)
      double precision lamold(maxng),betold(maxng,maxcov)
      double precision mu(maxng,max),piold(maxng),piest(maxng)
      double precision xi(maxng,max),pi(maxng),s(maxng,max)
      double precision sumlam(maxng),ssqlam(maxng),ll,llold
      double precision sumpi(maxng),ssqpi(maxng),h(maxng,max)
      double precision sumbet(maxng,maxcov),ssqbet(maxng,maxcov)
      double precision mean(maxng,maxcov+1),var(maxng,maxcov+1)
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand
      intrinsic exp,abs,int,sqrt

      open(21,file='data.txt')
      open(25,file='output')

      read (21,*) n,ncov,ng,nboot
      if (nboot.ne.1) then
        print *, 'Input: maximum number of iterations'
        read *, maxit
      endif
      do 100 j=1,n
        read (21,*) tjtemp(j),(xjtemp(l,j),l=2,ncov),
     +	dtemp(j)
c        xjtemp(10,j)=xjtemp(10,j)-1.
        xjtemp(1,j)=1.
100   continue
      do 150 i=1,ng
        read (21,*) piest(i),lamest(i),(betest(i,l),l=1,ncov)
        write (25,*) piest(i),lamest(i),(betest(i,l),l=1,ncov)
150   continue
      if (nboot.ne.1) then
	print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix,iy,iz
        print *, 'Do you want to print out the estimates '
        print *, '  for each bootstrap?    INPUT: 1(Yes); 0(No)'
	read *, prest
      endif
      write (25,*) n 
      do 180 i=1,ng
	sumlam(i)=0.
	ssqlam(i)=0.
	sumpi(i)=0.
	ssqpi(i)=0.
	do 160 l=1,ncov
	  sumbet(i,l)=0.
	  ssqbet(i,l)=0.
160     continue
180   continue
      do 800 k=1,nboot
	print *, 'k= ', k   
210   do 300 j=1,n
	if (nboot.eq.1) then
	  number=j
        else
	  rand=random()
	  rand=1.+rand*float(n)
	  number=int(rand)
        endif
        tj(j)=tjtemp(number)
	do 250 l=1,ncov
          xj(l,j)=xjtemp(l,number)
250     continue
        d(j)=dtemp(number)
300   continue
      do 400 i=1,ng
        lambda(i)=lamest(i)
        lamold(i)=lamest(i)
        pi(i)=piest(i)
        piold(i)=piest(i)
	do 350 l=1,ncov
	  beta(i,l)=betest(i,l)
	  betold(i,l)=betest(i,l)
350     continue
400   continue
      do 500 j=1,n 
        do 440 i=1,ng
          mu(i,j)=0.
          do 420 l=1,ncov
            mu(i,j)=mu(i,j)+beta(i,l)*xj(l,j)
420       continue
          mu(i,j)=exp(mu(i,j))
440     continue
500   continue
      call calsh(n,ng,tj,lambda,mu,s,h)
      iter=1
510   call caltau(n,ng,pi,d,s,h,tau)
      call update(beta,lambda,pi,mu,nboot,ifail)
      if (ifail.ne.1.and.nboot.ne.1) goto 210
      if (iter.ge.maxit.and.nboot.ne.1) goto 210
      call calsh(n,ng,tj,lambda,mu,s,h)
      call findll(n,ng,lambda,tj,mu,s,h,pi,d,ll)
      if (nboot.eq.1) print *, 'iter= ', iter
      iter=iter+1
      if (nboot.eq.1) then
	if (ll.lt.llold) write (3,*) 'decreasing ll:'
	write (3,*) ll,ll-llold
	llold=ll
      endif
      do 600 i=1,ng
        do 570 l=1,ncov
          if (abs(betold(i,l)-beta(i,l)).gt.0.0001) goto 610
570     continue
        if (abs(lamold(i)-lambda(i)).gt.0.0001) goto 610
        if (abs(piold(i)-pi(i)).gt.0.0001) goto 610
600   continue
      if (nboot.ne.1) then     
      if (lambda(1).gt.lambda(2).or.beta(1,1).lt.beta(2,1)) goto 210
      endif
      goto 720
610   do 700 i=1,ng
        do 670 l=1,ncov
	  betold(i,l)=beta(i,l)
670     continue
        lamold(i)=lambda(i)
        piold(i)=pi(i)
700   continue
      goto 510
720   if (nboot.eq.1.or.prest.eq.1) then
	write (25,990) k,iter,ll
	do 730 i=1,ng
	  write (25,991) i
	  write (25,992) pi(i)
	  write (25,993) lambda(i)
	  write (25,994) (beta(i,l),l=1,ncov)
730     continue
      endif
      do 760 i=1,ng
	sumlam(i)=sumlam(i)+lambda(i)
	ssqlam(i)=ssqlam(i)+lambda(i)*lambda(i)
	sumpi(i)=sumpi(i)+pi(i)
	ssqpi(i)=ssqpi(i)+pi(i)*pi(i)
	do 740 l=1,ncov
	  sumbet(i,l)=sumbet(i,l)+beta(i,l)
	  ssqbet(i,l)=ssqbet(i,l)+beta(i,l)*beta(i,l)
740     continue
760   continue
800   continue
      if (nboot.ne.1) then
	write (25,995)
	do 820 i=1,ng
          mean(i,1)=sumpi(i)/float(nboot)
	  var(i,1)=ssqpi(i)/float(nboot)-mean(i,1)*mean(i,1)
          write (25,996) i,mean(i,1)
          write (25,997) i,sqrt(var(i,1))
820     continue
	write (25,998)
	do 840 i=1,ng
          mean(i,1)=sumlam(i)/float(nboot)
	  var(i,1)=ssqlam(i)/float(nboot)-mean(i,1)*mean(i,1)
          do 830 l=1,ncov
           mean(i,l+1)=sumbet(i,l)/float(nboot)
	   var(i,l+1)=ssqbet(i,l)/float(nboot)-mean(i,l+1)*mean(i,l+1)
830       continue
          write (25,996) i,(mean(i,l),l=1,ncov+1)
          write (25,997) i,(sqrt(var(i,l)),l=1,ncov+1)
840     continue
      endif
990   format('Bootstrap: ',I3,'   No of iteration: ',I5,
     +  '   Log-likelihood: ',F15.5)
991   format('Estimates for Group ',I2)
992   format(2X,'Pi: ',20F9.5)
993   format(2X,'Alpha: ',F9.5)
994   format(2X,'Beta: ',20F10.5)
995   format(/,'Bootstrap result for Pi:')
996   format(2X,'Mean: ',I3,21F10.5)
997   format(2X,'S.E.: ',I3,21F10.5)
998   format(/,'Bootstrap result for Alpha, Beta:')
c   find the information matrix of the coefficients
	do 821 j=1,n
	  write (2,*) j,tj(j)-1,(xj(l,j),l=2,ncov),tau(1,j)
	  if (tj(j).lt.30.) then
      	    if (tau(1,j).gt.tau(2,j)) write (3,*) j,tj(j)-1,1
      	    if (tau(1,j).lt.tau(2,j)) write (3,*) j,tj(j)-1,2
	  endif
821     continue
      stop
      end

      subroutine calsh(n,ng,tj,lambda,mu,s,h)
      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng
      double precision tj(max),lambda(maxng),mu(maxng,max)
      double precision s(maxng,max),h(maxng,max)
      intrinsic exp

      do 200 i=1,ng
        do 100 j=1,n
          s(i,j)=exp(-tj(j)**(lambda(i))*mu(i,j))
          h(i,j)=mu(i,j)*lambda(i)*tj(j)**(lambda(i)-1.)
100     continue
200   continue
      return
      end

      subroutine caltau(n,ng,pi,d,s,h,tau)
      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng,d(max)
      double precision pi(maxng),s(maxng,max),tau(maxng,max)
      double precision sums,sumf,h(maxng,max)

      do 100 j=1,n
	sums=0.
	sumf=0.
	do 50 i=1,ng
	  sums=sums+pi(i)*s(i,j)
	  sumf=sumf+pi(i)*s(i,j)*h(i,j)
50      continue
        tau(ng,j)=1.
	do 70 i=1,ng-1
	  if (d(j).eq.1) then
	    if (sumf.eq.0.) print *,'sumf=0 for ',j
	    tau(i,j)=pi(i)*s(i,j)*h(i,j)/sumf
          else
	    if (sums.eq.0.) print *,'sums=0 for ',j
	    tau(i,j)=pi(i)*s(i,j)/sums
          endif
          tau(ng,j)=tau(ng,j)-tau(i,j)
70      continue
100   continue
      return
      end

      subroutine update(beta,lambda,pi,mu,nboot,ifail)
      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ind,ne,nboot
      double precision xi(maxng,max),sumxi,sumtau(maxng)
      double precision pi(maxng),beta(maxng,maxcov)
      double precision lambda(maxng),mu(maxng,max)
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      intrinsic exp
      external evalfn,HYBRD1
      integer sizehy,ifail
      double precision x(maxng*maxcov),xtol
      double precision fvec(maxng*maxcov),work(3000)

      do 200 i=1,ng-1
        sumtau(i)=0.
        do 100 j=1,n
          sumtau(i)=sumtau(i)+tau(i,j)
100     continue
200   continue
      pi(ng)=1.
      do 250 i=1,ng-1
        pi(i)=sumtau(i)/float(n)
        pi(ng)=pi(ng)-pi(i)
250   continue
      do 700 group=1,ng
        ifail=0
        do 500 l=1,ncov
          x(l)=beta(group,l)
500     continue
        x(ncov+1)=lambda(group)
        xtol=0.000000001
	sizehy=3000
	ne=ncov+1
        call HYBRD1(evalfn,ne,x,fvec,xtol,ifail,work,sizehy)
c        if (nboot.eq.1) print *,'beta: ',group,(fvec(l),l=1,ncov)
        if (ifail.ne.1.and.nboot.eq.1) print *, 'ifail= ',ifail
        if (ifail.ne.1.and.nboot.ne.1) return
        do 600 l=1,ncov
          beta(group,l)=x(l)
600     continue
        do 650 j=1,n
          mu(group,j)=0.
          do 620 l=1,ncov
            mu(group,j)=mu(group,j)+beta(group,l)*xj(l,j)
620       continue
          mu(group,j)=exp(mu(group,j))
650     continue
        lambda(group)=x(ncov+1)
700   continue
      return
      end

      subroutine evalfn(ne,x,fvec,iflag)
      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer ne,iflag
      double precision x(*),fvec(*),tmp(maxcov+1)
      double precision tot(maxcov+1),temp,temp1,eta,logs
      common/comm1/xj,tj,tau,d,n,ng,ncov,group
      integer n,ng,ncov,group,d(max)
      double precision xj(maxcov,max),tau(maxng,max),tj(max)
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=x(l)
        fvec(l)=0.
50    continue
      do 300 j=1,n
        eta=0.
        do 100 l=1,ncov
          eta=eta+tmp(l)*xj(l,j)
100     continue
        logs=-tj(j)**(tmp(ncov+1))*exp(eta)
	temp=d(j)+logs
        do 200 l=1,ncov
          fvec(l)=fvec(l)+tau(group,j)*temp*xj(l,j)
200     continue
	temp1=d(j)*(1.+tmp(ncov+1)*log(tj(j)))
	temp=exp(eta)*tmp(ncov+1)*tj(j)**(tmp(ncov+1))*log(tj(j))
        fvec(ncov+1)=fvec(ncov+1)+tau(group,j)*(temp1-temp)
300   continue
      return
      end
      
      subroutine findll(n,ng,lambda,tj,mu,s,h,pi,d,ll)
      integer max,maxng,maxcov
      parameter(max=1687)
      parameter(maxng=3)
      parameter(maxcov=20)
      integer n,ng,d(max)
      double precision lambda(maxng),tj(max),mu(maxng,max)
      double precision s(maxng,max),h(maxng,max),pi(maxng)
      double precision ll,surv,temp
      intrinsic log

      ll=0. 
      do 100 j=1,n
	if (d(j).eq.1) then
	  temp=0.
	  do 50 i=1,ng
	    temp=temp+pi(i)*h(i,j)*s(i,j)
50        continue
	  ll=ll+log(temp)
	else
	  temp=0.
	  do 70 i=1,ng
	    temp=temp+pi(i)*s(i,j)
70        continue
	  ll=ll+log(temp)
	endif
100   continue
      return
      end
      
