c  modified on 18/4/2018 (use bootstrap to find SE)
c  modified on 4/2018 (for book)
c  see readme.txt (different residuals across groups)
c  have integrated csda_same "same residuals across groups" 
c  24/4/2012 (modified from csda.f for clustered data)
c  allow pi on covariates
c  N=no of genes, m=dimension of y_i, q=dimension of beta,
c  s1=dimension of U_i, s2=dimension of V, t=no of tissue types,
      include 'para.txt'
      integer m,q,s1,s2,col,row,iter,ifault,gp(20,mn),qe,diff,ind
      integer nboot,prest
      double precision beta(mg,mq),pi(mg,20,mn),sigma(mg,mq),thetau(mg)
      double precision thetav(mg),X(mm,mq),Z1(mm,ms),Z2(mm,ms)
      double precision y(20,mn,mm),ZZT1(mm,mm),ZZT2(mm,mm),IM(mm,mm)
      double precision tempqq(mq,mq),tempinv(mq,mq),XXX(mq,mm)
      double precision ll(500),A(mg,mm,mm),B(mg,mm,mm),Sig(mg,mm,mm)
      double precision Siginv(mg,mm,mm),Sigdet(mg),sumtau(mg,20),al
      double precision sumtr(mg,20,mm),f(20,mn),eta(mg,mm)
      double precision fk(20,mn,mg),e1(mg),e2(mg),e3(mg,mq),e4(mg,mq)
      double precision Ainv(mg,mm,mm),Adet(mg),Z1Ainv(ms,mm)
      double precision AsB(mg,mm,mm),AsBinv(mg,mm,mm),AsBdet(mg)
      double precision temps1m(ms,mm),temps2m(ms,mm),tempmm(mm,mm)
      double precision U(mg,20,mn,ms),V(mg,20,ms),eps(mg,20,mn,mm)
      double precision tempqm(mq,mm),cont1,cont2,t1,t2,ssigma(mq)
      double precision tempsm(ms,mm),tmpmm(mm,mm),tottau(mg)
      double precision trace,trace1,EN,W(mm,mq),D(mm,mm),Dm(mg,mm)
      double precision sumWc(mq),twopi,gamma(mg,20),sumxi,xi(mg)
      double precision ftau(20,mn),altau,dettau,fktau(20,mn,mg)
      double precision Stauinv(mg,mm,mm),Staudet(mg),Stau(mg,mm,mm)
      double precision tauf(20,mn,mg),tol1,tol2
      double precision betest(mg,mq),gamest(mg,20),sigest(mg,mq)
      double precision thuest(mg),thvest(mg),ytmp(20,mn,mm)
      double precision xjtmp(20,mn,20),mean(mg,20),var(mg,20)
      double precision sumbet(mg,mq),sumgam(mg,20),sumsig(mg,mq)
      double precision sumthu(mg),sumthv(mg)
      double precision ssqbet(mg,mq),ssqgam(mg,20),ssqsig(mg,mq)
      double precision ssqthu(mg),ssqthv(mg)
      intrinsic log,exp,abs
      external evalfg,HYBRD1
      integer sizehy,ifail,neq
      double precision xtol,fvec((mg-1)*20),work(50000),xx((mg-1)*20)
      common/comm1/xj,tau,nm,ng,ncov,ni
      integer nm,ng,ncov,ni(20)
      double precision xj(20,mn,20),tau(20,mn,mg)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand

      open(20,file='init3.dat')
      open(21,file='NLSY79C_671.txt')
      open(25,file='output')

      read (20,*) N,m,q,s1,ng,twopi,qe,nm,ncov
      s2=m
      read (20,*) (ni(i),i=1,nm)
      print *, 'Different residuals across groups? (1/0) '
      read *, diff
c   read initial estimates
      do 10 k=1,ng 
        read (20,*) (betest(k,l),l=1,q)
10    continue
      do 11 k=1,ng-1
        read (20,*) (gamest(k,l),l=1,ncov)
11    continue
      do 12 l=1,qe
        read (20,*) (sigest(k,l),k=1,ng)
12    continue
      read (20,*) (thuest(k),k=1,ng)
      read (20,*) (thvest(k),k=1,ng)
      write (25,*) 'INITIAL EST:'  
      do 15 k=1,ng
        write (25,*) (betest(k,l),l=1,q)
15    continue
      do 16 k=1,ng-1
        write (25,*) (gamest(k,l),l=1,ncov)
16    continue
      do 18 l=1,qe
        write (25,*) (sigest(k,l),k=1,ng)
18    continue
      write (25,*) (thuest(k),k=1,ng)
      write (25,*) (thvest(k),k=1,ng)
      write (25,*) 
c   read design matrices
      do 30 row=1,m 
        read (20,*) (X(row,l),l=1,q)
30    continue
      do 40 row=1,m 
        read (20,*) (Z1(row,l),l=1,s1)
40    continue
      do 50 row=1,m 
        read (20,*) (Z2(row,l),l=1,s2)
        do 45 k=1,ng
	  do 43 i=1,nm  
	    V(k,i,row)=0.   
43        continue
45      continue
50    continue
      do 60 row=1,m 
        read (20,*) (W(row,l),l=1,qe)
60    continue
      do 70 l=1,qe
	sumWc(l)=0.
	do 65 kk=1,m
	  sumWc(l)=sumWc(l)+W(kk,l)
65      continue
70    continue
c   read data
      do 80 i=1,nm 
        do 75 j=1,ni(i)
          read (21,*) (ytmp(i,j,l),l=1,m),(xjtmp(i,j,k),k=2,ncov)
c          read (21,*) t2,(y(i,j,l),l=1,m),(xj(i,j,k),k=2,ncov)
c          read (21,*) (y(i,j,l),l=1,m),(xj(i,j,k),k=2,ncov)
c       read (21,*) t1,t2,(ytmp(i,j,l),l=1,m),t1,t2,(xjtmp(i,j,k),k=2,3),
c     +      t1,(xjtmp(i,j,k),k=4,ncov)
c       read (21,*) t1,t2,(ytmp(i,j,l),l=1,m),(xjtmp(i,j,k),k=2,5),
c     +      t1,(xjtmp(i,j,k),k=6,ncov)
c change on 24/7/18          read (21,*) t1,t2,(ytmp(i,j,l),l=1,m),(xjtmp(i,j,k),k=2,ncov)
          xjtmp(i,j,1)=1.
75      continue
80    continue
      print *, 'INPUT: no. of bootstrap (enter 1 for original data)'
      read *, nboot
      if (nboot.ne.1) then
	print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix, iy, iz
	print *, 'Do you want to print out the estimates '
	print *, '  for each bootstrap?     INPUT: 1(Yes); 0(No)'
        read *, prest
      endif
      do 84 i=1,ng
	do 81 l=1,q   
	  sumbet(i,l)=0.
	  ssqbet(i,l)=0.
81      continue
	if (i.lt.ng) then   
	  do 82 l=1,ncov
	    sumgam(i,l)=0.
	    ssqgam(i,l)=0.
82        continue
	endif
	do 83 l=1,qe   
	  sumsig(i,l)=0.
	  ssqsig(i,l)=0.
83      continue
        sumthu(i)=0.
        ssqthu(i)=0.
        sumthv(i)=0.
        ssqthv(i)=0.
84    continue
      do 888 kboot=1,nboot
	if (nboot.ne.1) print *, 'k= ', kboot
201   do 90 i=1,nm
	do 89 j=1,ni(i)        
	  if (nboot.eq.1) then
	    number=j
          else
	    rand=random()
	    rand=1.+rand*float(ni(i))
	    number=int(rand)
          endif
	  do 87 l=1,m            
            y(i,j,l)=ytmp(i,number,l)
87        continue
	  do 88 l=1,ncov         
            xj(i,j,l)=xjtmp(i,number,l)
88        continue
89      continue
90    continue
      do 96 i=1,ng
	do 92 l=1,q   
	  beta(i,l)=betest(i,l)
92      continue
	if (i.lt.ng) then   
	  do 93 l=1,ncov
	    gamma(i,l)=gamest(i,l)
93        continue
	endif
	do 94 l=1,qe   
	  sigma(i,l)=sigest(i,l)
94      continue
        thetau(i)=thuest(i)
        thetav(i)=thvest(i)
96    continue
      iter=0
c   make matrix ZZ^T= ZZT: (m*m) matrix
c   make identity matrix IM: (m*m) matrix
c   make matrix X^TX= tempqq: (q*q) matrix
c   make matrix (X^TX)^{-1} X^T= XXX: (q*m) matrix
      call mult1(m,s1,Z1,ZZT1)
      call mult1(m,s2,Z2,ZZT2)
      do 110 row=1,m
	do 100 col=1,m
	  IM(row,col)=0.
100     continue
	IM(row,row)=1.
110   continue
      call mult2(q,m,X,tempqq)
      call matinv0(q,tempqq,tempinv,ifault)
      if (ifault.ne.0) then
	write (25,*) 'ERROR in matinv0: ifault = ',ifault
	do 163 l=1,q
	  write (25,990) (tempqq(l,kk),kk=1,q)
163     continue
        stop
      endif
      call multt0(q,q,q,m,tempinv,X,XXX)
      tol1=175.
      tol2=.0001
      if (q.ge.20) then
	tol1=375.
	tol2=.001
      endif
171   iter=iter+1
c   E-step 
      ll(iter)=0. 
c   make matrices A and B: m*m matrix
      do 200 k=1,ng
c   make matrix D: diagonal m*m matrix
        call diag(m,qe,W,sigma,k,D,Dm)
	cont1=1.
	cont2=thetau(k)
	call add2(m,cont1,D,cont2,ZZT1,k,A)
	cont1=0.
	cont2=thetav(k)
	call add2(m,cont1,IM,cont2,ZZT2,k,B)
	cont2=0.
	call add3(m,k,A,cont2,B,Stau)
	call matinv(m,Stau,Stauinv,k,Staudet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv1: ifault= ',ifault
	  do 193 l=1,m
	    write (25,*) (Stau(k,l,kk),kk=1,m)
193       continue
	  stop
	endif
	cont2=1.
	call add3(m,k,A,cont2,B,Sig)
	call matinv(m,Sig,Siginv,k,Sigdet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv2: ifault= ',ifault
	  do 195 l=1,m
	    write (25,*) (Sig(k,l,kk),kk=1,m)
195       continue
	  stop
	endif
	tottau(k)=0. 
	do 198 i=1,nm
	  sumtau(k,i)=0.
	  do 197 l=1,m
	    sumtr(k,i,l)=0.
197       continue
198     continue
200   continue
c   get pi(k,j)
      do 805 i=1,nm
       do 804 j=1,ni(i)
        sumxi=0.
        do 802 k=1,ng-1
          xi(k)=0.
          do 801 l=1,ncov
            xi(k)=xi(k)+gamma(k,l)*xj(i,j,l)
801       continue
          xi(k)=exp(xi(k))
          sumxi=sumxi+xi(k)
802     continue
        pi(ng,i,j)=1.
        do 803 k=1,ng-1
          pi(k,i,j)=xi(k)/(1.+sumxi)
          pi(ng,i,j)=pi(ng,i,j)-pi(k,i,j)   
803     continue
804    continue
805   continue
c   get tau(i,k)
      do 250 i=1,nm
       do 249 j=1,ni(i)
	f(i,j)=0.
	ftau(i,j)=0.
	do 230 k=1,ng 
          al=0.
          altau=0.
c   make matrix X*beta_k= eta: (m*1) matrix
          call mults1(m,q,X,beta,k,eta)
	  do 210 row=1,m 
	    do 205 col=1,m 
	      altau=altau+(y(i,j,row)-eta(k,row)-V(k,i,row))*
     +	         Stauinv(k,row,col)*(y(i,j,col)-eta(k,col)-V(k,i,col))        
	      al=al+(y(i,j,row)-eta(k,row))*Siginv(k,row,col)*
     +	         (y(i,j,col)-eta(k,col))        
205         continue
210       continue
	  if (al.gt.tol1) then
	    fk(i,j,k)=0.
	    goto 220
	  else
	    if (m.lt.50) then
	      fk(i,j,k)=exp(-.5*al)/(sqrt(Sigdet(k))*(twopi)**(m*.5))
	    else
	      fk(i,j,k)=exp(-.5*al)/sqrt(Sigdet(k))
	    endif
	  endif
220	  f(i,j)=f(i,j)+pi(k,i,j)*fk(i,j,k)
	  if (altau.gt.tol1) then
	    fktau(i,j,k)=0.
	    goto 225
	  else 
	    if (m.lt.50) then
	      fktau(i,j,k)=exp(-.5*altau)/
     +	      (sqrt(Staudet(k))*(twopi)**(m*.5))
	    else
	      fktau(i,j,k)=exp(-.5*altau)/sqrt(Staudet(k))
	    endif
	  endif
225	  ftau(i,j)=ftau(i,j)+pi(k,i,j)*fktau(i,j,k)
230     continue
	do 240 k=1,ng
	  if (f(i,j).eq.0.) then
	    tau(i,j,k)=0.
c	    if (nboot.eq.1) print *,'f(i,j)=0: ',i,j
	  endif
	  if (ftau(i,j).eq.0.) then
	    tauf(i,j,k)=0.
c	    if (iter.gt.10) write (25,*) 'ftau(i,j)=0: ',i
	  endif
	  if (ftau(i,j).eq.0.) goto 233
     	  tauf(i,j,k)=pi(k,i,j)*fktau(i,j,k)/ftau(i,j)
233	  if (f(i,j).eq.0.) goto 240
	  tau(i,j,k)=pi(k,i,j)*fk(i,j,k)/f(i,j)
	  sumtau(k,i)=sumtau(k,i)+tau(i,j,k)
	  tottau(k)=tottau(k)+tau(i,j,k)
	  do 235 l=1,m
	    sumtr(k,i,l)=sumtr(k,i,l)+tau(i,j,k)*(y(i,j,l)-eta(k,l))
235       continue
240     continue
c   calculate log likelihood
        if (f(i,j).eq.0.) goto 250
	if (m.lt.50) then
          ll(iter)=ll(iter)+log(f(i,j))
	else
          ll(iter)=ll(iter)+log(f(i,j))-m*.5*log(twopi)
	endif
249    continue
250   continue
c      if (nboot.eq.1) print *,'iter: ',iter,ll(iter)
c      if (nboot.eq.1) write (25,*) iter,ll(iter)
      if (nboot.eq.1) print *,'iter: ',iter
c   for U^TU   
c   make matrix Z1^T A_k^{-1}= Z1Ainv: (s1*m) matrix
c   make matrix (A_k+sumtau B)= AsB: (m*m) matrix
c   make matrix Z1^T A_k^{-1} B= tempsm: (s1*m) matrix
c   make matrix Z1^TA_k^{-1}B(A_k+sumtau B)^{-1}= temps1m: (s1*m) matrix
      do 300 k=1,ng
	e1(k)=0.
	call matinv(m,A,Ainv,k,Adet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv (e1): ifault= ',ifault
	  do 255 l=1,m
	    write (25,*) (A(k,l,kk),kk=1,m)
255       continue
	  stop
	endif
        call multt2(s1,m,m,m,Z1,Ainv,k,Z1Ainv)
	do 275 i=1,nm
	cont2=sumtau(k,i)
	call add3(m,k,A,cont2,B,AsB)
	call matinv(m,AsB,AsBinv,k,AsBdet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv (e11): ifault= ',ifault
	  do 260 l=1,m
	    write (25,*) (AsB(k,l,kk),kk=1,m)
260       continue
	  stop
	endif
        call multt3(s1,m,m,m,Z1Ainv,B,k,tempsm)
        call multt3(s1,m,m,m,tempsm,AsBinv,k,temps1m)
c	do 275 i=1,nm
	 do 274 j=1,ni(i)
	  do 270 l=1,s1
	    U(k,i,j,l)=0.  
	    do 265 kk=1,m
	      U(k,i,j,l)=U(k,i,j,l)+thetau(k)*(Z1Ainv(l,kk)*
     +	      (y(i,j,kk)-eta(k,kk))-temps1m(l,kk)*sumtr(k,i,kk))
265         continue
	    e1(k)=e1(k)+tau(i,j,k)*U(k,i,j,l)**2
270       continue
274      continue
	 e1(k)=e1(k)+sumtau(k,i)*s1*thetau(k)
     +   -(sumtau(k,i)-1.)*(thetau(k))**2
     +	 *trace(s1,m,Z1,Ainv,k)-(thetau(k))**2*trace(s1,m,Z1,AsBinv,k)
275     continue
c	e1(k)=e1(k)+sumtau(k,i)*s1*thetau(k)-(sumtau(k,i)-1.)*(thetau(k))**2
c     +	*trace(s1,m,Z1,Ainv,k)-(thetau(k))**2*trace(s1,m,Z1,AsBinv,k)
300   continue
c   for V^TV   
c   make matrix Z2^T (A_k+sumtau B)^{-1}= temps2m: (s2*m) matrix
      do 320 k=1,ng
	e2(k)=0.
	do 317 i=1,nm
	cont2=sumtau(k,i)
	call add3(m,k,A,cont2,B,AsB)
	call matinv(m,AsB,AsBinv,k,AsBdet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv (e2): ifault= ',ifault
	  do 305 l=1,m
	    write (25,*) (AsB(k,l,kk),kk=1,m)
305       continue
	  stop
	endif
	call multt2(s2,m,m,m,Z2,AsBinv,k,temps2m)
	do 315 l=1,s2
	  V(k,i,l)=0.
	  do 310 kk=1,m
	    V(k,i,l)=V(k,i,l)+thetav(k)*temps2m(l,kk)*sumtr(k,i,kk)
310       continue
	  e2(k)=e2(k)+V(k,i,l)**2
315     continue
	e2(k)=e2(k)+s2*thetav(k)-sumtau(k,i)*(thetav(k))**2*
     +	trace(s2,m,Z2,AsBinv,k)
317    continue
320   continue
c   for epsilon^T epsilon
c   make matrix A_k^{-1}B(A_k+sumtau B)^{-1}= tempmm: (m*m) matrix
      do 350 k=1,ng
        do 323 l=1,qe
	  e3(k,l)=0.
323     continue
        call multt4(m,m,m,m,Ainv,B,k,tmpmm)
	do 345 i=1,nm
	cont2=sumtau(k,i)
	call add3(m,k,A,cont2,B,AsB)
	call matinv(m,AsB,AsBinv,k,AsBdet,ifault)
	if (ifault.ne.0) then
	  write (25,*) 'ERROR in matinv (e3): ifault= ',ifault
	  do 324 l=1,m
	    write (25,*) (AsB(k,l,kk),kk=1,m)
324       continue
	  stop
	endif
        call multt4a(m,m,m,m,tmpmm,AsBinv,k,tempmm)
	do 335 j=1,ni(i)
	  do 330 l=1,m 
	    eps(k,i,j,l)=0.
	    do 325 kk=1,m
	      eps(k,i,j,l)=eps(k,i,j,l)+Dm(k,kk)*(Ainv(k,l,kk)*
     +	      (y(i,j,kk)-eta(k,kk))-tempmm(l,kk)*sumtr(k,i,kk))
325         continue
	    do 327 kkk=1,qe
	      e3(k,kkk)=e3(k,kkk)+W(l,kkk)*tau(i,j,k)*eps(k,i,j,l)**2
327         continue
330       continue
335     continue
	do 340 l=1,qe
	  e3(k,l)=e3(k,l)+sumtau(k,i)*sumWc(l)*sigma(k,l)
     +	  -(sumtau(k,i)-1.)*(sigma(k,l))**2*trace1(m,Ainv,W,k,l)
     +    -(sigma(k,l))**2*trace1(m,AsBinv,W,k,l)
340     continue
345    continue
350   continue
c   for beta
c   make matrix (X^TX)^{-1}X^T(A_k+sumtau B)^{-1}= tempqm: (q*m) matrix
      do 400 k=1,ng
	do 370 l=1,q
	  e4(k,l)=0.
	  do 365 i=1,nm
	    cont2=sumtau(k,i)
	    call add3(m,k,A,cont2,B,AsB)
	    call matinv(m,AsB,AsBinv,k,AsBdet,ifault)
	    if (ifault.ne.0) then
	    write (25,*) 'ERROR in matinv (e4): ifault= ',ifault
	    do 355 j=1,m
	      write (25,*) (AsB(k,j,kk),kk=1,m)
355         continue
	    stop
	    endif
	    call multt5(q,m,m,m,XXX,AsBinv,k,tempqm)
	  do 360 kk=1,m
	    e4(k,l)=e4(k,l)+Dm(k,kk)*tempqm(l,kk)*sumtr(k,i,kk)
360       continue
365      continue
370     continue
400   continue
c   M-step 
c   for gamma (call HYBRD1)
      ind=1 
      do 402 k=1,ng-1
        do 401 l=1,ncov
          xx(ind)=gamma(k,l)
          ind=ind+1
401     continue
402   continue
      ifail=0
      neq=(ng-1)*ncov
      xtol=0.000000001
      sizehy=50000
      call HYBRD1(evalfg,neq,xx,fvec,xtol,ifail,work,sizehy)
      if (ifail.ne.1) print *, 'ifail= ',ifail
      ind=1
      do 404 k=1,ng-1
        do 403 l=1,ncov
          gamma(k,l)=xx(ind)
          ind=ind+1
403     continue
404   continue
      do 708 i=1,nm
       do 707 j=1,ni(i)
        sumxi=0.
        do 703 k=1,ng-1
          xi(k)=0.
          do 702 l=1,ncov
            xi(k)=xi(k)+gamma(k,l)*xj(i,j,l)
702       continue
          xi(k)=exp(xi(k))
          sumxi=sumxi+xi(k)
703     continue
        pi(ng,i,j)=1.
        do 704 k=1,ng-1
          pi(k,i,j)=xi(k)/(1.+sumxi)
          pi(ng,i,j)=pi(ng,i,j)-pi(k,i,j)   
704     continue
707    continue
708   continue
      do 405 l=1,qe
        ssigma(l)=0.
405   continue
      do 450 k=1,ng
c        pi(k)=tottau(k)/float(N)
        thetau(k)=e1(k)/(tottau(k)*s1)
        thetav(k)=e2(k)/float(s2)  
	do 410 l=1,qe
         if (diff.eq.1) sigma(k,l)=e3(k,l)/(tottau(k)*sumWc(l))
         if (diff.eq.0) ssigma(l)=ssigma(l)+e3(k,l)/(tottau(k)*sumWc(l))
410     continue
	do 420 l=1,q
	  beta(k,l)=beta(k,l)+e4(k,l)/tottau(k)
420     continue
450   continue
      if (diff.eq.0) then
	do 460 k=1,ng
	  do 455 l=1,qe
	    sigma(k,l)=ssigma(l)/float(ng)
455       continue
460     continue
      endif
      if (iter.eq.500.and.nboot.eq.1) goto 470
      if (iter.eq.250.and.nboot.ne.1) goto 470
      if (iter.lt.11) goto 171
      if (abs(ll(iter)-ll(iter-10)).gt.abs(tol2*ll(iter-10)))
     +  goto 171
c  output the result
470   if (nboot.eq.1.or.prest.eq.1) then        
       write (25,*) 'niter,ll: ',iter,ll(iter)
       write (25,*) 'FINAL EST: '
       do 500 k=1,ng
        write (25,*) (beta(k,l),l=1,q)
500    continue
       do 505 k=1,ng-1
        write (25,*) (gamma(k,l),l=1,ncov)
505    continue
       write (25,*) (thetau(k),k=1,ng)
       write (25,*) (thetav(k),k=1,ng)
c       EN=0. 
       do 510 l=1,qe
        write (25,*) (sigma(k,l),k=1,ng)
510    continue
       do 550 i=1,nm
        do 545 j=1,ni(i)
   	 gp(i,j)=1
         do 520 k=1,ng
	  if (tauf(i,j,k).gt.tauf(i,j,gp(i,j))) gp(i,j)=k
c	  if (tauf(i,j,k).gt.0.) EN=EN-tauf(i,j,k)*log(tauf(i,j,k))
520      continue
545     continue
550    continue
       if (nboot.eq.1) then           
         do 600 i=1,nm
           write (25,991) (gp(i,j),j=1,ni(i))
600      continue
         goto 890   
       endif
      endif
      do 760 i=1,ng
	do 740 l=1,q
	  sumbet(i,l)=sumbet(i,l)+beta(i,l)
	  ssqbet(i,l)=ssqbet(i,l)+beta(i,l)*beta(i,l)
740     continue
	if (i.lt.ng) then 
         do 745 l=1,ncov
	  sumgam(i,l)=sumgam(i,l)+gamma(i,l)
	  ssqgam(i,l)=ssqgam(i,l)+gamma(i,l)*gamma(i,l)
745     continue
	endif
	do 750 l=1,qe
	  sumsig(i,l)=sumsig(i,l)+sigma(i,l)
	  ssqsig(i,l)=ssqsig(i,l)+sigma(i,l)*sigma(i,l)
750     continue
        sumthu(i)=sumthu(i)+thetau(i)
        ssqthu(i)=ssqthu(i)+thetau(i)*thetau(i)
        sumthv(i)=sumthv(i)+thetav(i)
        ssqthv(i)=ssqthv(i)+thetav(i)*thetav(i)
760   continue
888   continue
890   if (nboot.ne.1) then
	write (25,995)
	do 820 i=1,ng
          do 810 l=1,q   
           mean(i,l)=sumbet(i,l)/float(nboot)
	   var(i,l)=ssqbet(i,l)/float(nboot)-mean(i,l)*mean(i,l)
810       continue
          write (25,992) i,(mean(i,l),l=1,q)
          write (25,993) i,(sqrt(var(i,l)),l=1,q)
820     continue
	write (25,996)
	do 840 i=1,ng-1
          do 830 l=1,ncov
            mean(i,l)=sumgam(i,l)/float(nboot)
	    var(i,l)=ssqgam(i,l)/float(nboot)-mean(i,l)*mean(i,l)
830       continue
          write (25,992) i,(mean(i,l),l=1,ncov)
          write (25,993) i,(sqrt(var(i,l)),l=1,ncov)
840     continue
	write (25,998)
	do 860 i=1,ng
          do 850 l=1,qe
           mean(i,l)=sumsig(i,l)/float(nboot)
	   var(i,l)=ssqsig(i,l)/float(nboot)-mean(i,l)*mean(i,l)
850       continue
       mean(i,qe+1)=sumthu(i)/float(nboot)
       var(i,qe+1)=ssqthu(i)/float(nboot)-mean(i,qe+1)*mean(i,qe+1)
       mean(i,qe+2)=sumthv(i)/float(nboot)
       var(i,qe+2)=ssqthv(i)/float(nboot)-mean(i,qe+2)*mean(i,qe+2)
          write (25,992) i,(mean(i,l),l=1,qe+2)
          write (25,993) i,(sqrt(var(i,l)),l=1,qe+2)
860     continue
      endif
992   format(2X,'Mean: ',I3,21F9.5)
993   format(2X,'S.E.: ',I3,21F9.5)
995   format(/,'Bootstrap result for Beta:')
996   format(/,'Bootstrap result for Gamma:')
998   format(/,'Bootstrap result for Sigma, Thetau, Thetav:')
999   format(/,'No. of observations:',I6)
990   format(100F15.9)
991   format(10I4)
      stop
      end

      subroutine mult1(nr,nc,m1,newmat)
      include 'para.txt'
      integer nr,nc,rw,cn
      double precision m1(mm,ms)
      double precision newmat(mm,mm)

      do 200 rw=1,nr
	do 100 cn=1,nr
	  newmat(rw,cn)=0.
	  do 50 l=1,nc 
	    newmat(rw,cn)=newmat(rw,cn)+m1(rw,l)*m1(cn,l)
50        continue
100     continue
200   continue
      return
      end

      subroutine mult2(nr,nc,m1,newmat)
      include 'para.txt'
      integer nr,nc,rw,cn
      double precision m1(mm,mq)   
      double precision newmat(mq,mq)

      do 200 rw=1,nr
	do 100 cn=1,nr
	  newmat(rw,cn)=0.
	  do 50 l=1,nc 
	    newmat(rw,cn)=newmat(rw,cn)+m1(l,rw)*m1(l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multt0(nr1,nc1,nr2,nc2,m1,m2,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision m1(mq,mq),m2(mm,mq),newmat(mq,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(rw,l)*m2(cn,l)
50        continue
100     continue
200   continue
      return
      end

      subroutine mults1(nr,nc,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr,nc,rw,cn,ind
      double precision m1(mm,mq),m2(mg,mq),newmat(mg,mm)

      do 200 rw=1,nr
	  newmat(ind,rw)=0.
	  do 50 l=1,nc
	    newmat(ind,rw)=newmat(ind,rw)+m1(rw,l)*m2(ind,l)
50        continue
200   continue
      return
      end

      subroutine add2(nr1,cont1,m1,cont2,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision cont1,cont2
      double precision m1(mm,mm),m2(mm,mm),newmat(mg,mm,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nr1
	  newmat(ind,rw,cn)=m1(rw,cn)*cont1+m2(rw,cn)*cont2
100     continue
200   continue
      return
      end

      subroutine add3(nr1,ind,m1,cont2,m2,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision cont2,m1(mg,mm,mm)
      double precision m2(mg,mm,mm),newmat(mg,mm,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nr1
	  newmat(ind,rw,cn)=m1(ind,rw,cn)+m2(ind,rw,cn)*cont2
100     continue
200   continue
      return
      end

      subroutine multt2(nr1,nc1,nr2,nc2,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(mm,ms),m2(mg,mm,mm)
      double precision newmat(ms,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(l,rw)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multt3(nr1,nc1,nr2,nc2,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(ms,mm),m2(mg,mm,mm)
      double precision newmat(ms,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(rw,l)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine diag(nr,nc,m1,m2,ind,newmat,new)
      include 'para.txt'
      integer nr,nc,rw,cn,ind
      double precision m1(mm,mq),m2(mg,mq),newmat(mm,mm),new(mg,mm)

      do 200 rw=1,nr
        do 100 cn=1,nr
	  newmat(rw,cn)=0.
100     continue
	do 150 l=1,nc
	  newmat(rw,rw)=newmat(rw,rw)+m1(rw,l)*m2(ind,l)
150     continue
	new(ind,rw)=newmat(rw,rw)
200   continue
      return
      end

      function trace(nr1,nc1,m1,m2,ind)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(mm,ms),m2(mg,mm,mm)
      double precision newmat(ms,mm),trace

      do 200 rw=1,nr1
	do 100 cn=1,nc1
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(l,rw)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      trace=0.
      do 300 rw=1,nr1
	do 250 l=1,nc1
	  trace=trace+newmat(rw,l)*m1(l,rw)
250     continue
300   continue
      return
      end

      function trace1(nr1,m1,m2,ind,ind1)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind,ind1
      double precision m1(mg,mm,mm),m2(mm,mq),trace1

      trace1=0.
      do 300 rw=1,nr1
	trace1=trace1+m1(ind,rw,rw)*m2(rw,ind1)
300   continue
      return
      end

      subroutine multt4(nr1,nc1,nr2,nc2,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(mg,mm,mm),m2(mg,mm,mm)
      double precision newmat(mm,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(ind,rw,l)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multt4a(nr1,nc1,nr2,nc2,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(mm,mm),m2(mg,mm,mm)
      double precision newmat(mm,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(rw,l)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multt5(nr1,nc1,nr2,nc2,m1,m2,ind,newmat)
      include 'para.txt'
      integer nr1,nc1,nr2,nc2,rw,cn,ind
      double precision m1(mq,mm),m2(mg,mm,mm)
      double precision newmat(mq,mm)

      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+m1(rw,l)*m2(ind,l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine matinv0(nv,m1,m2,ierr)
      include 'para.txt'
      integer nv,rw,cn,ctr,nullty,ifault,ierr
      double precision m1(mq,mq),m2(mq,mq)
      double precision arr1(mq*(mq+1)),arr2(mq*(mq+1))
      double precision cmy(mq*(mq+1)),work(mq)
      integer IP(mq)
      double precision E(mq,mq+1)
                       
      DO 100 MI=1,nv
        DO 50 MJ=1,MI
          E(MI,MJ)=m1(MI,MJ)
          E(MJ,MI)=E(MI,MJ)
50      CONTINUE
100   CONTINUE
      TOL=0.000001
      IERR=0
      DO 200 MI=1,nv
        IP(MI)=MI
200   CONTINUE
      DO 650 L=1,nv
C   Search for pivot
        IR=L 
        EMAX=0.0
        DO 250 MI=L,nv
          IF (ABS(E(MI,L)).LE.ABS(EMAX)) GOTO 250
          EMAX=E(MI,L)
          IR=MI
250     CONTINUE
C   Record pivot row
        MI=IP(L)
        IP(L)=IP(IR)
        IP(IR)=MI
C   Test for zero pivot
        IF (EMAX.NE.0) GOTO 300
        IERR=1
        RETURN
C   Move selected pivot row to pivot row
300     IF (IR.EQ.L) GOTO 400
        DO 350 MJ=1,nv
          TEMP=E(IR,MJ)
          E(IR,MJ)=E(L,MJ)
          E(L,MJ)=TEMP
350     CONTINUE
C   Transform matrix
400     DO 450 MJ=1,nv
          E(L,MJ)=E(L,MJ)/EMAX
450     CONTINUE
        DO 550 MI=1,nv
          IF (MI.EQ.L) GOTO 550
          DO 500 MJ=1,nv
            IF (MJ.EQ.L) GOTO 500
            T1=E(MI,MJ)
            T2=E(MI,L)*E(L,MJ)
            T3=T1-T2
            IF (ABS(T3).LT.(ABS(T1)+ABS(T2))*TOL) T3=0.0
            E(MI,MJ)=T3
500       CONTINUE
550     CONTINUE
        DO 600 MI=1,nv
          E(MI,L)=-E(MI,L)/EMAX
600     CONTINUE
        E(L,L)=1.0/EMAX
650   CONTINUE
C   Realign inverse
      DO 850 L=1,nv
        DO 700 MJ=1,nv
          IF (L.EQ.IP(MJ)) GOTO 750
700     CONTINUE
750     IF (MJ.EQ.L) GOTO 850
        DO 800 MI=1,nv
          TEMP=E(MI,MJ)
          E(MI,MJ)=E(MI,L)
          E(MI,L)=TEMP
800     CONTINUE
          MI=IP(L)
          IP(L)=IP(MJ)
          IP(MJ)=MI
850   CONTINUE
      IF (IERR.EQ.1) IERR=3
      IF (IERR.EQ.2) IERR=0
      IF (IERR.NE.0) RETURN
      DO 890 MI=1,nv
        DO 870 MJ=1,MI
          m2(MI,MJ)=E(MI,MJ)
          m2(MJ,MI)=m2(MI,MJ)
870     CONTINUE
890   CONTINUE
      RETURN
      END

      subroutine matinv(nv,m1,m2,ind,det,ierr)
      include 'para.txt'
      integer nv,rw,cn,ctr,nullty,ifault,ind,ierr
      double precision m1(mg,mm,mm),m2(mg,mm,mm)
      double precision det(mg),arr1(mm*(mm+1))
      double precision arr2(mm*(mm+1))
      double precision cmy(mm*(mm+1)),work(mm)
      integer IP(mm)
      double precision E(mm,mm+1)
                       
      DO 100 MI=1,nv
        DO 50 MJ=1,MI
          E(MI,MJ)=m1(ind,MI,MJ)
          E(MJ,MI)=E(MI,MJ)
50      CONTINUE
100   CONTINUE
      TOL=0.000001
      IERR=0
150   DET(ind)=1.0
      DO 200 MI=1,nv
        IP(MI)=MI
200   CONTINUE
      DO 650 L=1,nv
C   Search for pivot
        IR=L 
        EMAX=0.0
        DO 250 MI=L,nv
          IF (ABS(E(MI,L)).LE.ABS(EMAX)) GOTO 250
          EMAX=E(MI,L)
          IR=MI
250     CONTINUE
        DET(ind)=DET(ind)*EMAX
C   Record pivot row
        MI=IP(L)
        IP(L)=IP(IR)
        IP(IR)=MI
C   Test for zero pivot
        IF (EMAX.NE.0) GOTO 300
        IERR=1
        RETURN
C   Move selected pivot row to pivot row
300     IF (IR.EQ.L) GOTO 400
        DO 350 MJ=1,nv
          TEMP=E(IR,MJ)
          E(IR,MJ)=E(L,MJ)
          E(L,MJ)=TEMP
350     CONTINUE
        DET(ind)=-DET(ind)
C   Transform matrix
400     DO 450 MJ=1,nv
          E(L,MJ)=E(L,MJ)/EMAX
450     CONTINUE
        DO 550 MI=1,nv
          IF (MI.EQ.L) GOTO 550
          DO 500 MJ=1,nv
            IF (MJ.EQ.L) GOTO 500
            T1=E(MI,MJ)
            T2=E(MI,L)*E(L,MJ)
            T3=T1-T2
            IF (ABS(T3).LT.(ABS(T1)+ABS(T2))*TOL) T3=0.0
            E(MI,MJ)=T3
500       CONTINUE
550     CONTINUE
        DO 600 MI=1,nv
          E(MI,L)=-E(MI,L)/EMAX
600     CONTINUE
        E(L,L)=1.0/EMAX
650   CONTINUE
C   Realign inverse
      DO 850 L=1,nv
        DO 700 MJ=1,nv
          IF (L.EQ.IP(MJ)) GOTO 750
700     CONTINUE
750     IF (MJ.EQ.L) GOTO 850
        DO 800 MI=1,nv
          TEMP=E(MI,MJ)
          E(MI,MJ)=E(MI,L)
          E(MI,L)=TEMP
800     CONTINUE
          MI=IP(L)
          IP(L)=IP(MJ)
          IP(MJ)=MI
850   CONTINUE
      IF (IERR.EQ.1) IERR=3
      IF (IERR.EQ.2) IERR=0
      IF (IERR.NE.0) RETURN
      DO 890 MI=1,nv
        DO 870 MJ=1,MI
          m2(ind,MI,MJ)=E(MI,MJ)
          m2(ind,MJ,MI)=m2(ind,MI,MJ)
870     CONTINUE
890   CONTINUE
      RETURN
      END

      subroutine evalfg(ne,x,fvec,iflag)
      include 'para.txt'
      integer ne,iflag,ind
      double precision x(*),fvec(*),tmp(mg,20)
      double precision tot(21),temp,temp1,te,pi
      double precision sumxi,xi(mg)
      common/comm1/xj,tau,nm,ng,ncov,ni
      integer nm,ng,ncov,ni(20)
      double precision xj(20,mn,20),tau(20,mn,mg)
      intrinsic exp     

      ind=1
      do 150 k=1,ng-1
	do 120 l=1,ncov
	  tmp(k,l)=x(ind) 
	  fvec(ind)=0.
	  ind=ind+1
120     continue
150   continue
      do 300 i=1,nm  
       do 290 j=1,ni(i)
	sumxi=0.
        do 180 k=1,ng-1
	  xi(k)=0.
          do 160 l=1,ncov
	    xi(k)=xi(k)+tmp(k,l)*xj(i,j,l)
160       continue
	  xi(k)=exp(xi(k))
	  sumxi=sumxi+xi(k)
180     continue
        do 220 k=1,ng-1
c	  pi=xi(k)/(1.+sumxi)
	  do 200 l=1,ncov
            temp=tau(i,j,k)-xi(k)/(1.+sumxi)
            fvec((k-1)*ncov+l)=fvec((k-1)*ncov+l)+temp*xj(i,j,l)
200       continue
220     continue
290    continue
300   continue
      return
      end
