
setwd("c:/Example8.2/") 
require(emmixskew) 
source("Emmixwire_time_course.R") 

datafile <- read.table("norm_cellcycle_384_17.txt", header=T)
orgCluster2 <- datafile[,2] 
data <- datafile[,-c(1,2)] 

m <- 17
time <- seq(from=0, by=10, length=17) 
period <- 85

U <- W <- cbind(rep(1,m))
V <- diag(m)

ng=5 
set.seed(457) 

initclust <- sample(1:ng,384,replace=T)
obj5 <- emmixwire(data, ng, ncov="AR", nvcov=1, tmtype=T, one=0, common=0,
clust=initclust, debug=0, itmax=1000, epsilon=1e-5,
tmpoints=time, k=1, periods=85, initperiod=rep(period,ng))
initclust <- obj5$clust

obj5 <- emmixwire(data, ng, ncov="AR", nvcov=1, tmtype=T, one=0, common=0,
clust=initclust, debug=0, itmax=1000, epsilon=1e-6,
tmpoints=time, k=1, periods=85, initperiod=rep(period,ng))

x11()
clust.plot.time(obj5$clust, data, base=4, nr=3)

profile <- array(0,c(384,17))
for (j in 1:384) {
for (m in 1:17) {
profile[j,m] <- obj5$mu[m,obj5$clust[j]] + obj5$eb1[j,m,obj5$clust[j]] +
obj5$ec1[m,obj5$clust[j]] }}
mprof <- t(obj5$tau)%*%profile
for (i in 1:ng) {
mprof[i,] <- mprof[i,]/sum(obj5$clust==i) }

datat <- mprof
source("corr_lag.R") 
mat1 <- cbind(corr1, corr2, corr3, corr4, corr5, corr6)
mat2 <- cbind(pv1, pv2, pv3, pv4, pv5, pv6)
mat <- rbind(mat1, mat2)
write.csv(mat,"corr_lag.csv")












