      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer iter,mix,want,nboot,ng,number,order(3),ch
      double precision pi(5),alpha(5),beta(5,maxcov),fct(5,max)
      double precision piold(5),alpold(5),betold(5,maxcov)
      double precision ll,se(2,maxcov),oldbet(5,maxcov),oldalp(5)
      double precision llold,sumpi1(5),ssqpi1(5),sumalp(5),ssqalp(5)   
      double precision sumbet(5,maxcov),ssqbet(5,maxcov)   
      double precision pi1old,pi2old,nul(15)
      double precision xjtemp(maxcov,max),tjtemp(max)
      double precision piest(5),alpest(5),betest(5,maxcov)
      double precision mean(5,maxcov),var(5,maxcov)
      double precision fitted,ttemp,ttemp1,ttem,chisq,devi
      common/comm1/xj,mu,tau,tj,n,ncov,group
      integer n,ncov,group
      double precision mu(5,max),xj(maxcov,max),tj(max)
      double precision tau(5,max)
      common/randc/ix,iy,iz
      integer ix,iy,iz
      real random,rand           
      intrinsic abs,int,sqrt

      open(21,file='gammadata.txt')

      read (21,*) n,ncov,nboot
      print *, 'Adopt single or mixed gamma distribution? (0/1)'
      read *, mix
      if (mix.eq.1) then
	print *, 'How many components?'
        read *, ng  
	print *, 'Do you want the output of tau? (0/1)'
        read *, want
      endif
      do 50 j=1,n
        read (21,*) tjtemp(j),(xjtemp(l,j),l=2,ncov)
c        read (21,*) tjtemp(j),xjtemp(2,j),nul(1),xjtemp(3,j),
c     +   xjtemp(4,j),nul(2),(xjtemp(l,j),l=5,9),nul(3),     
c     +   xjtemp(10,j),nul(4),nul(5),xjtemp(11,j)
        xjtemp(1,j)=1.
50    continue
      piest(ng)=1.
      do 55 i=1,ng-1
        read (21,*) piest(i),alpest(i),betest(i,1)
        piest(ng)=piest(ng)-piest(i)
55    continue
        print *, piest(1),alpest(1),betest(1,1)
      read (21,*) alpest(ng),betest(ng,1)
      if (mix.eq.0) piest(1)=1.
      do 100 i=1,ng  
        do 80 l=2,ncov
          betest(i,l)=0.
80      continue
100   continue
      write (25,990) piest(1),piest(2),alpest(1),alpest(2),
     +  betest(1,1),betest(2,1)
      write (25,*) piest(ng),alpest(ng),betest(ng,1)
      if (nboot.ne.1) then
        print *, 'Input the seeds for random number generation: ',
     +  'input 3 integers between 1 and 30,000, e.g. 23 120 3411.'
        read *, ix, iy, iz
      endif
      do 110 i=1,ng
        sumpi1(i)=0.
        ssqpi1(i)=0.
        sumalp(i)=0.
        ssqalp(i)=0.
        do 105 l=1,ncov
          sumbet(i,l)=0.
          ssqbet(i,l)=0.
105     continue
110   continue
      do 700 k=1,nboot
       print *, 'k= ', k
75     do 120 j=1,n
         if (nboot.eq.1) then
           number=j
         else
           rand=random()
           rand=1.+rand*float(n)
           number=int(rand)
         endif
         tj(j)=tjtemp(number)
         do 115 l=1,ncov
          xj(l,j)=xjtemp(l,number)
115      continue
120    continue
      do 150 i=1,ng
       pi(i)=piest(i)
       piold(i)=piest(i)
       alpha(i)=alpest(i)
       oldalp(i)=alpest(i)
       do 140 l=1,ncov
        beta(i,l)=betest(i,l)
        oldbet(i,l)=betest(i,l)
140    continue
150   continue
      do 400 i=1,ng
        do 300 j=1,n
          mu(i,j)=0.
          do 200 l=1,ncov
            mu(i,j)=mu(i,j)+beta(i,l)*xj(l,j)
200       continue
          mu(i,j)=exp(mu(i,j))
300     continue
400   continue
      call calpdf(n,ng,alpha,mu,tj,fct)
      do 410 i=1,ng
        piold(i)=pi(i)
410   continue
      iter=1
500   call caltau(n,ng,pi,fct,tau)
      call update(n,ng,ncov,pi,tau,beta,alpha,group,mix)
      if (nboot.ne.1) then
        do 510 ii=1,ng
          if (alpha(ii).gt.10.) goto 75
          if (alpha(ii).lt.0.1) goto 75
510   continue
      endif
      call calpdf(n,ng,alpha,mu,tj,fct)
      call findll(n,ng,pi,fct,ll)
      if (nboot.eq.1) print *, 'iter= ',iter
      iter=iter+1
      do 520 i=1,ng
        if (abs(piold(i)-pi(i)).gt.0.000001) then
          do 515 m=1,ng                      
            piold(m)=pi(m)
515       continue
          goto 500
        endif
520   continue
      do 560 i=1,ng
        do 550 l=1,ncov
          if (abs(oldbet(i,l)-beta(i,l)).gt.0.0001) then
           do 545 m=1,ng                      
             do 535 ml=1,ncov                    
              oldbet(m,ml)=beta(m,ml)
535          continue
545        continue
           goto 500
          endif
550     continue
560   continue
      do 570 i=1,ng  
        if (abs(oldalp(i)-alpha(i)).gt.0.000001) then
          do 565 m=1,ng     
            oldalp(m)=alpha(m)
565       continue
          goto 500
        endif
570   continue
      ch=0
      if (nboot.ne.1) ch=1
      if (beta(1,1).lt.beta(2,1).and.beta(2,1).lt.beta(3,1)) ch=0
      if (ch.eq.1) then
        order(1)=1
        do 573 kk=2,ng 
          if (beta(kk,1).lt.beta(order(1),1)) order(1)=kk
573     continue
        ind=1
        do 575 kk=1,ng
          if (order(1).ne.kk) then
            order(ind+1)=kk
            ind=ind+1
          endif
575     continue
        if (beta(order(2),1).gt.beta(order(3),1)) then
          kk=order(2)
          order(2)=order(3)
          order(3)=kk
        endif
        do 585 i=1,ng
          piold(i)=pi(i)
          alpold(i)=alpha(i)
          do 583 l=1,ncov
            betold(i,l)=beta(i,l)
583       continue
585     continue
        do 587 i=1,ng
          pi(i)=piold(order(i))
          alpha(i)=alpold(order(i))
          do 586 l=1,ncov
            beta(i,l)=betold(order(i),l)
586       continue
587     continue
      endif
      do 620 i=1,ng
        sumpi1(i)=sumpi1(i)+pi(i)
        ssqpi1(i)=ssqpi1(i)+pi(i)*pi(i)
        sumalp(i)=sumalp(i)+alpha(i)
        ssqalp(i)=ssqalp(i)+alpha(i)*alpha(i)
        do 610 l=1,ncov
          sumbet(i,l)=sumbet(i,l)+beta(i,l)
          ssqbet(i,l)=ssqbet(i,l)+beta(i,l)*beta(i,l)
610     continue
620   continue
700   continue
c  find the information matrix of the coefficients
705   if (mix.eq.1.and.want.eq.1) then
	do 580 j=1,n
	  write (2,991) tau(1,j)
580     continue
      endif
c      call calse(n,ncov,pi,fct,alpha,mu,tj,xj,se)
      write (25,992) n,iter,ll
      if (nboot.eq.1) then
      write (25,994) pi(1),pi(2),alpha(1),alpha(2)
      if (ng.eq.3) write (25,996) pi(3),alpha(3)
      do 600 l=1,ncov
	if (mix.eq.0) write (25,995) beta(1,l),se(1,l)
	if (mix.eq.1) write (25,997) (beta(i,l),i=1,ng)
c	if (mix.eq.1) write (25,997) beta(1,l),se(1,l),
c     +    beta(2,l),se(2,l)
c	if (ng.eq.3) write (25,996) beta(3,l)
600   continue
c  use chisqregr.f
      chisq=0.
      devi=0.
      do 805 j=1,n   
        fitted=0.
        do 802 i=1,ng
          fitted=fitted+tau(i,j)*mu(i,j)
802     continue
        ttemp1=fitted*fitted
        ttemp=(tj(j)-fitted)**2/ttemp1
        ttem=-log(tj(j)/fitted)+(tj(j)-fitted)/fitted 
        chisq=chisq+ttemp      
        devi=devi+ttem      
        write (25,*) j,tj(j),(tau(i,j),i=1,ng)
c        write (25,*) j,tj(j),(tau(i,j),i=1,ng),fitted,ttemp
805   continue
      write (25,*) 
      write (25,*) chisq,2*devi,n-ng+1-ng*(ncov+1)
      else
        write (25,*) 'Results of bootstrapping: '
        do 810 i=1,ng
          mean(i,1)=sumpi1(i)/float(nboot)
          var(i,1)=ssqpi1(i)/float(nboot)-mean(i,1)*mean(i,1)
          write (25,998) i,mean(i,1),sqrt(var(i,1))
810     continue
        do 820 i=1,ng
          mean(i,1)=sumalp(i)/float(nboot)
          var(i,1)=ssqalp(i)/float(nboot)-mean(i,1)*mean(i,1)
          write (25,998) i,mean(i,1),sqrt(var(i,1))
820     continue
        do 830 i=1,ng
         do 825 l=1,ncov
          mean(i,l)=sumbet(i,l)/float(nboot)
          var(i,l)=ssqbet(i,l)/float(nboot)-mean(i,l)*mean(i,l)
825      continue
         write (25,998) i,(mean(i,l),l=1,ncov)
         write (25,998) i,(sqrt(var(i,l)),l=1,ncov)
830     continue
       endif
990   format ('Initial estimates:',/2x,'pi(1)=',F9.4,'  pi(2)=',
     +  F9.4,'  alpha(1)=',F9.5,'  alpha(2)=',F9.5,/,2x,
     +  'beta(1,1)=',F9.5,'  beta(2,1)=',F9.5)
991   format (F9.7)
992   format ('Total number of observations=',I5,/2x,
     +  ': After ',I4,' iterations, the log-likelihood is ',F13.5)
994   format (/,'Final estimates:',/,2x,'pi(1)=',F9.4,'  pi(2)=',
     +  F9.4,/,2x,'alpha(1)=',F9.4,'  alpha(2)=',F9.4,/,2x)
c     +  ,'Coefficients:')
995   format (4x,F9.5,' (',F7.5,')')
996   format ('  pi(3)=',F9.4,/,2x,'alpha(3)=',F9.4,/)
c997   format (4x,F9.5,' (',F7.5,')',8x,F9.5,' (',F7.5,')')
997   format (4x,3F9.5)
998   format (I3,20F9.5)
      stop
      end

      subroutine calpdf(n,ng,alpha,mu,tj,fct)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer n,ng,ifail  
      double precision tj(max),alpha(5),mu(5,max),fct(5,max)
      double precision gam,temp
      real S14AAF
c      external S14AAF
      intrinsic exp,gamma

      do 200 i=1,ng
        gam=gamma(alpha(i))
c        if (ifail.ne.0) print *, 'ERROR in S14AAF'
        do 100 j=1,n
          temp=(alpha(i)/mu(i,j))**alpha(i)*tj(j)**(alpha(i)-1.)
          fct(i,j)=temp*exp(-alpha(i)*tj(j)/mu(i,j))/gam
100     continue
200   continue
      return
      end

      subroutine caltau(n,ng,pi,fct,tau)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer n,ng
      double precision pi(5),fct(5,max),tau(5,max),sumtemp

      do 200 j=1,n
        sumtemp=0.
        do 50 i=1,ng
          sumtemp=sumtemp+pi(i)*fct(i,j)
50      continue
        tau(ng,j)=1.
        do 100 i=1,ng-1
          tau(i,j)=pi(i)*fct(i,j)/sumtemp
          tau(ng,j)=tau(ng,j)-tau(i,j)
100     continue
200   continue
      return
      end

      subroutine update(n,ng,ncov,pi,tau,beta,alpha,group,mix)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer n,ng,ncov,group,mix
      double precision pi(5),tau(5,max),beta(5,maxcov),sumtau
      double precision alpha(5)
      external evalfn,HYBRD1
      integer sizehy,ifail
      double precision x(maxcov+1),xtol,fvec(maxcov+1),work(1000)

      pi(ng)=1.
      do 150 i=1,ng-1
        sumtau=0.
        do 100 j=1,n
          sumtau=sumtau+tau(i,j)
100     continue
        pi(i)=sumtau/float(n)
        pi(ng)=pi(ng)-pi(i)
150   continue
      if (mix.eq.0) pi(1)=1.
c      pi(2)=1.-pi(1)
c      print *, (pi(i),i=1,3) 
      do 400 group=1,ng
        ifail=0
        do 200 l=1,ncov
          x(l)=beta(group,l)
200     continue
        x(ncov+1)=alpha(group)
        xtol=0.00000000001
        sizehy=1000
        call HYBRD1(evalfn,ncov+1,x,fvec,xtol,ifail,work,sizehy)
c        print *, group, (fvec(l),l=1,ncov+1)
c        if (ifail.ne.1) print *, 'ifail= ',ifail
        do 300 l=1,ncov
          beta(group,l)=x(l)
300     continue
        alpha(group)=x(ncov+1)
        if (mix.eq.0) return  
400   continue
      return
      end

      subroutine evalfn(ne,x,fvec,iflag)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer ne,iflag
      double precision x(*),fvec(*),tmp(maxcov+1),tot(maxcov+1)
      double precision temp,eta
      common/comm1/xj,mu,tau,tj,n,ncov,group
      integer n,ncov,group
      double precision mu(5,max),xj(maxcov,max),tj(max)
      double precision tau(5,max)
      integer ifail,nn,nm
      real tmpr,w
c      external S14ADF
      external psifn 
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=x(l)
        tot(l)=0.
50    continue
      nn=0
      nm=1
      tmpr=real(tmp(ncov+1))
      call psifn(tmpr,nn,1,nm,w,nz,ifail)
      if (ifail.ne.0) print *, 'ERROR in S14ADF'
      do 300 j=1,n
        eta=0.
        do 100 l=1,ncov
          eta=eta+tmp(l)*xj(l,j)
100     continue
        mu(group,j)=exp(eta)
        temp=tau(group,j)*(-1.+tj(j)/mu(group,j))*tmp(ncov+1)
        do 200 l=1,ncov
          tot(l)=tot(l)+temp*xj(l,j)
200     continue
        temp=1.+log(tmp(ncov+1)*tj(j))-eta-tj(j)/mu(group,j)
        tot(ncov+1)=tot(ncov+1)+(temp+dble(w))*tau(group,j)
300   continue
      do 400 l=1,ne
        fvec(l)=tot(l)
400   continue
      return
      end
      
      subroutine findll(n,ng,pi,fct,ll)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer n,ng
      double precision pi(5),fct(5,max),ll,sumtemp
      intrinsic log

      ll=0. 
      do 100 j=1,n
        sumtemp=0.
        do 50 i=1,ng
          sumtemp=sumtemp+pi(i)*fct(i,j)
50      continue
        if (sumtemp.eq.0.) goto 100
        ll=ll+log(sumtemp)
100   continue
      return
      end
      
      subroutine calse(n,ncov,pi,fct,alpha,mu,tj,xj,se)
      integer max,maxcov
      parameter(max=1000)
      parameter(maxcov=20)
      integer n,ncov,ctr,nullty,ifault
      double precision tj(max),pi(5),fct(5,max),alpha(5),mu(5,max)
      double precision xj(maxcov,max),se(2,maxcov),temp,t1,t2
      intrinsic sqrt
	real arr(maxcov,maxcov)
	real matrix(maxcov*(maxcov+1))
	real inv(maxcov*(maxcov+1))
	real work(maxcov)

      i=1
20    do 100 k=1,ncov
	do 50 l=1,ncov
	  arr(k,l)=0.
50      continue
100   continue
      do 400 k=1,ncov
	do 300 l=k,ncov
	  do 200 j=1,n
            temp=pi(1)*fct(1,j)+pi(2)*fct(2,j)
	    t1=pi(i)*alpha(i)*(1.-tj(j)/mu(i,j))*fct(i,j)/temp
	    t1=t1*t1*xj(k,j)*xj(l,j)
	    t2=-(1.-tj(j)/mu(i,j))**2*alpha(i)+tj(j)/mu(i,j)
	    t2=t2*pi(i)*alpha(i)*xj(k,j)*xj(l,j)*fct(i,j)/temp
	    arr(k,l)=arr(k,l)+t1+t2
200       continue
	  arr(l,k)=arr(k,l)
300     continue
400   continue
	ctr=0
	do 500 k=1,ncov 
	  do 450 l=1,k
	    ctr=ctr+1
	    matrix(ctr)=arr(k,l)
450       continue
500     continue
	nullty=0
	ifault=0
	call syminv(matrix,ncov,ctr,inv,work,nullty,ifault)
	if(ifault .ne. 0) then
	  print *,'Error in inversion routine: ifault = ',ifault
	  stop
	endif
	ctr=0
	do 600 k=1,ncov 
	  do 550 l=1,k
	    ctr=ctr+1
	    arr(k,l)=inv(ctr)
550       continue
600     continue
	do 700 k=1,ncov 
	  se(i,k)=sqrt(arr(k,k))
700     continue
      if (i.ne.2) then
	i=2
	goto 20
      endif  
990   format (20F9.1)
      return 
      end

