      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nv,ni(mm),ctr,rw,cn,cw,rbegin,cbegin,ind,cter,iter
      integer order1,order2,dummy,ifault,finish,cind(mm,mni)
      double precision sigsq1,sigsq2,siold1,siold2
      double precision gamma(mp),beta1(mp),beta2(mp),xij(mm,mni,mp)
      double precision u1(mm),u2(mm),v(mm),yij(mm,mni)
      double precision C(3*mn,3*mp+3*mm),eta1(mn),eta2(mn)
      double precision xi(mn),pi(mn),f1(mn),f2(mn),f(mn)
      double precision nd2x(mn,mn),nd2xe1(mn,mn),nd2xe2(mn,mn)
      double precision nd2e1(mn,mn),nd2e12(mn,mn),nd2e2(mn,mn)
      double precision W(3*mn,3*mn),E(3*mp+3*mm,3*mp+3*mm)
      double precision EINV(3*mp+3*mm,3*mp+3*mm),CT(3*mp+3*mm,3*mn)
      double precision dx(mn),de1(mn),de2(mn),A(3*mn),B(3*mp+3*mm)
      double precision D(3*mp+3*mm,3*mp+3*mm),twopi,tol
      double precision varg(mp),varb1(mp),varb2(mp)
      double precision EST(3*mp+3*mm),ESTNEW(3*mp+3*mm)
      double precision tempm1(mn),temp1,temp2,temp3,temp4,temp5
      double precision tempm2(3*mp+3*mm,3*mn),tempm3(3*mp+3*mm)
      double precision tempm4(2,2),tempm5(2,2)
      double precision h1(mn),h2(mn),s1(mn),s2(mn),s(mn)
      double precision diagw1,diagw2(mn),diagw3(mn),XT(mp,mn)
      double precision ZT(mm,mn),tempp1(mp),tempmm1(mm),temppn(mp,mn)
      double precision temppp(mp,mp),tempmn(mm,mn),tempmp(mm,mp)
      double precision tempmm(mm,mm)
      common/comm1/X,Y,Z,tau,lambda,theta1,theta2,p,M,N,group
      integer p,M,N,group
      double precision X(mn,mp),Y(mn),Z(mn,mm),tau(2,mn)
      double precision lambda,theta1,theta2
      common/comm2/CEN
      integer CEN(mn)

      open(21,file='data.txt')
      open(25,file='output')

      N=0
      read (21,*) M,nv
      p=nv+1
      read (21,*) (ni(i),i=1,M)
      read (21,*) sigsq1,sigsq2,lambda,theta1,theta2
      read (21,*) (gamma(l),l=1,p)
      read (21,*) (beta1(l),l=1,p)
      read (21,*) (beta2(l),l=1,p)
      ctr=0
      read (21,*) twopi,tol
c   make matrix u1 and u2: (M*1) matrix
c   make matrix v: (M*1) matrix
c   make matrix X: (N*p) matrix
c   make matrix Y: (N*1) matrix
c   make matrix Z: (N*M) matrix
c   make matrix CEN: (N*1) matrix
      do 80 i=1,M
	u1(i)=0. 
	u2(i)=0.
	v(i)=0.
	do 70 j=1,ni(i)
          read (21,*) yij(i,j),(xij(i,j,l),l=2,p),cind(i,j)
          xij(i,j,1)=1
	  ctr=ctr+1
	  Y(ctr)=yij(i,j)
	  CEN(ctr)=cind(i,j)
	  do 50 l=1,p
	    X(ctr,l)=xij(i,j,l)
50        continue
	  do 60 cn=1,M
	    Z(ctr,cn)=0.
60        continue
	  Z(ctr,i)=1.
70      continue
80    continue
      N=ctr
c   initial EST
      EST(1)=gamma(1)
      do 85 l=1,p
        EST(l+1)=beta1(l)
        EST(p+l+1)=beta2(l)
85    continue
      do 90 l=1,M
        EST(2*p+l+1)=u1(l)
        EST(2*p+M+l+1)=u2(l)
90    continue
c   make matrix C: 3N*(1+2*p+2*M) matrix
      do 120 rw=1,3*N
        do 110 cn=1,1+2*p+2*M
	  C(rw,cn)=0
110     continue
120   continue
      do 200 rw=1,N
        C(rw,1)=X(rw,1)
	do 150 cn=1,p
          C(N+rw,cn+1)=X(rw,cn)
          C(2*N+rw,p+cn+1)=X(rw,cn)
150     continue
200   continue
      do 300 rw=1,N          
	do 250 cn=1,M
          C(N+rw,1+2*p+cn)=Z(rw,cn)
          C(2*N+rw,1+2*p+M+cn)=Z(rw,cn)
250     continue
300   continue
      iter=0
      ind=0
      cter=0
      siold1=sigsq1
      siold2=sigsq2
c      write (25,*) ind,theta1,theta2,sigsq1,sigsq2
c   loop
303   iter=iter+1
      print *,'iter= ',iter
      cter=cter+1
c   make matrix D: (1+2*p+2*M)*(1+2*p+2*M) matrix
      do 320 rw=1,1+2*p+2*M
        do 310 cn=1,1+2*p+2*M
	  D(rw,cn)=0.
310     continue
320   continue
      rbegin=1+2*p
      do 350 i=1,M           
        D(rbegin+i,rbegin+i)=1./theta1
        D(rbegin+M+i,rbegin+M+i)=1./theta2
350   continue
c   make matrix eta1 and eta2: (N*1) matrix
      call munp1(N,p,p,1,X,beta1,eta1)
      call munm1(N,M,M,1,Z,u1,tempm1)
      call add1(N,eta1,tempm1,eta1)
      call munp1(N,p,p,1,X,beta2,eta2)
      call munm1(N,M,M,1,Z,u2,tempm1)
      call add1(N,eta2,tempm1,eta2)
c   make matrix xi: (N*1) matrix
      call munp1(N,p,p,1,X,gamma,xi)
      call munm1(N,M,M,1,Z,v,tempm1)
      call add1(N,xi,tempm1,xi)
c   make matrix pi,f1,f2,h1,h2,s1,s2,f,s: (N*1) matrix
      do 400 rw=1,N
	if (xi(rw).gt.70.) then
	  pi(rw)=1.
	  goto 397
	endif
	if (xi(rw).lt.-70.) then
	  pi(rw)=0.
	  goto 397
	endif
	pi(rw)=exp(xi(rw))/(1.+exp(xi(rw)))
397	h1(rw)=exp(eta1(rw))*sigsq1*Y(rw)**(sigsq1-1.)
   	h2(rw)=exp(eta2(rw))*sigsq2*Y(rw)**(sigsq2-1.)
   	s1(rw)=exp(-Y(rw)**sigsq1*exp(eta1(rw)))
   	s2(rw)=exp(-Y(rw)**sigsq2*exp(eta2(rw)))
   	f1(rw)=h1(rw)*s1(rw)
   	f2(rw)=h2(rw)*s2(rw)
   	f(rw)=pi(rw)*f1(rw)+(1.-pi(rw))*f2(rw)
   	s(rw)=pi(rw)*s1(rw)+(1.-pi(rw))*s2(rw)
c   get tau(i,j)
	if (CEN(rw).eq.0.) then
	  tau(1,rw)=pi(rw)*s1(rw)/s(rw)
	  goto 399
	endif
	tau(1,rw)=pi(rw)*f1(rw)/f(rw)
399	tau(2,rw)=1.-tau(1,rw)
400   continue
c   update gamma(1),beta_i,u1,u2,sigsqi
      call update(EST,ESTNEW,sigsq1,sigsq2)
      finish=1
      if (abs(gamma(1)-ESTNEW(1)).gt.tol) finish=0
      gamma(1)=ESTNEW(1)
      do 755 l=1,p
        if (abs(beta1(l)-ESTNEW(1+l)).gt.tol) finish=0
        if (abs(beta2(l)-ESTNEW(1+p+l)).gt.tol) finish=0
        beta1(l)=ESTNEW(1+l)
        beta2(l)=ESTNEW(1+p+l)
755   continue
      do 760 l=1,M
        if (abs(u1(l)-ESTNEW(1+2*p+l)).gt.tol) finish=0
        if (abs(u2(l)-ESTNEW(1+2*p+M+l)).gt.tol) finish=0
        u1(l)=ESTNEW(1+2*p+l)
        u2(l)=ESTNEW(1+2*p+M+l)
760   continue
      if (abs(siold1-sigsq1).gt.tol) finish=0
      if (abs(siold2-sigsq2).gt.tol) finish=0
      siold1=sigsq1
      siold2=sigsq2
c   convergence criterion in the Newton Raphson procedure
      if (finish.eq.0) then
        do 765 l=1,1+2*p+2*M
	  EST(l)=ESTNEW(l)
765     continue
cc      write (25,*) iter,(EST(l),l=1,1+2*p+2*M)
cc      write (25,*) 'sigma: ',sigsq1,sigsq2,finish
	ind=1000*tol
        goto 303	
      endif
      diagw1=0.
cc      print *,'estimation of variance component',iter
c   make second derivative matrices: (N*N) matrix
      do 500 rw=1,N
	do 450 cn=1,N
	  nd2x(rw,cn)=0.
	  nd2xe1(rw,cn)=0.
	  nd2xe2(rw,cn)=0.
	  nd2e1(rw,cn)=0.
	  nd2e12(rw,cn)=0.
	  nd2e2(rw,cn)=0.
	  if (rw.eq.cn) then
	    temp1=pi(rw)*(1.-pi(rw))
	    temp2=(f1(rw)-f2(rw))/f(rw)
	    temp3=(s1(rw)-s2(rw))/s(rw)
	    temp4=temp1*(CEN(rw)*temp2+(1.-CEN(rw))*temp3)
	    temp5=CEN(rw)*temp2*temp2+(1.-CEN(rw))*temp3*temp3
	    nd2x(rw,cn)=(2.*pi(rw)-1.)*temp4+temp1*temp1*temp5
	    diagw1=diagw1+nd2x(rw,cn)
	    temp2=CEN(rw)*f1(rw)*f2(rw)/(f(rw)*f(rw))
	    temp3=(1.-CEN(rw))*s1(rw)*s2(rw)/(s(rw)*s(rw))
	    if (s1(rw).eq.0.) then
	      nd2xe1(rw,cn)=0.
	      diagw2(rw)=0.
	      goto 778
	    endif
	    temp5=temp2*(1.+log(s1(rw)))+temp3*log(s1(rw))
	    nd2xe1(rw,cn)=-temp1*temp5
	    diagw2(rw)=nd2xe1(rw,cn)
778	    if (s2(rw).eq.0.) then
	      nd2xe2(rw,cn)=0.
	      diagw3(rw)=0.
	      goto 779
	    endif
	    temp5=temp2*(1.+log(s2(rw)))+temp3*log(s2(rw))
	    nd2xe2(rw,cn)=-temp1*temp5
	    diagw3(rw)=nd2xe2(rw,cn)
779	    if (s1(rw).eq.0.) then
	      nd2e1(rw,cn)=0.
	      goto 781
	    endif
	    temp2=(1.+log(s1(rw)))**2
	    temp3=f(rw)*(temp2+log(s1(rw)))-pi(rw)*f1(rw)*temp2
	    temp2=s(rw)*log(s1(rw))*(1.+log(s1(rw)))
	    temp4=temp2-pi(rw)*s1(rw)**2*(log(s1(rw)))**2
	    nd2e1(rw,cn)=-pi(rw)*(CEN(rw)*f1(rw)*temp3/(f(rw)**2)+
     +	      (1.-CEN(rw))*s1(rw)*temp4/(s(rw)**2))
781	    if (s1(rw).eq.0..or.s2(rw).eq.0.) then
	      nd2e12(rw,cn)=0.
	      goto 782
	    endif
	    temp4=f1(rw)*f2(rw)*(1.+log(s1(rw)))*(1.+log(s2(rw)))
	    temp5=s1(rw)*s2(rw)*log(s1(rw))*log(s2(rw))
	    nd2e12(rw,cn)=temp1*(CEN(rw)*temp4/(f(rw)**2)+
     +	      (1.-CEN(rw))*temp5/(s(rw)**2))
782	    if (s2(rw).eq.0.) then
	      nd2e2(rw,cn)=0.
	      goto 450
	    endif
	    temp1=(1.-pi(rw))*f2(rw)
	    temp2=(1.+log(s2(rw)))**2
	    temp3=f(rw)*(temp2+log(s2(rw)))-temp1*temp2
	    temp2=s(rw)*log(s2(rw))*(1.+log(s2(rw)))
	    temp4=temp2-(1.-pi(rw))*s2(rw)**2*(log(s2(rw)))**2
	    nd2e2(rw,cn)=-(1.-pi(rw))*(CEN(rw)*f2(rw)*temp3/
     +	      (f(rw)**2)+(1.-CEN(rw))*s2(rw)*temp4/(s(rw)**2))
	  endif
450     continue
500   continue
      print *,'finish second derivative matrices'         
c   make matrix W: (3N)*(3N) matrix (not required in this version)
c   make matrix CTWC: (1+2*p+2*M)*(1+2*p+2*M) matrix
      E(1,1)=diagw1          
      order1=N
      order2=p
      call trans1(order1,order2,X,XT)
      call mupn1(p,N,N,1,XT,diagw2,tempp1)
      do 505 rw=1,p
	E(rw+1,1)=tempp1(rw)
505   continue
      call multi2(p,N,N,N,XT,nd2e1,temppn)
      call multi3(p,N,N,p,temppn,X,temppp)
      do 509 rw=1,p
        do 507 cw=1,p
	  E(rw+1,cw+1)=temppp(rw,cw)
507     continue
509   continue
      call mupn1(p,N,N,1,XT,diagw3,tempp1)
      do 511 rw=1,p
	E(rw+p+1,1)=tempp1(rw)
511   continue
      call multi2(p,N,N,N,XT,nd2e12,temppn)
      call multi3(p,N,N,p,temppn,X,temppp)
      do 516 rw=1,p
        do 513 cw=1,p
	  E(rw+p+1,cw+1)=temppp(rw,cw)
513     continue
516   continue
      call multi2(p,N,N,N,XT,nd2e2,temppn)
      call multi3(p,N,N,p,temppn,X,temppp)
      do 521 rw=1,p
        do 518 cw=1,p
	  E(rw+p+1,cw+p+1)=temppp(rw,cw)
518     continue
521   continue
      order2=M
      call trans2(order1,order2,Z,ZT)
      call mumn1(M,N,N,1,ZT,diagw2,tempmm1)
      do 526 rw=1,M
	E(rw+2*p+1,1)=tempmm1(rw)
526   continue
      call multi4(M,N,N,N,ZT,nd2e1,tempmn)
      call multi5(M,N,N,p,tempmn,X,tempmp)
      call multi6(M,N,N,M,tempmn,Z,tempmm)
      do 531 rw=1,M
        do 528 cw=1,p
	  E(rw+2*p+1,cw+1)=tempmp(rw,cw)
528     continue
        do 529 cw=1,M
	  E(rw+2*p+1,cw+2*p+1)=tempmm(rw,cw)
529     continue
531   continue
      call mumn1(M,N,N,1,ZT,diagw3,tempmm1)
      do 533 rw=1,M
	E(rw+M+2*p+1,1)=tempmm1(rw)
533   continue
      call multi4(M,N,N,N,ZT,nd2e12,tempmn)
      call multi5(M,N,N,p,tempmn,X,tempmp)
      call multi6(M,N,N,M,tempmn,Z,tempmm)
      do 538 rw=1,M
        do 536 cw=1,p
	  E(rw+2*p+1,cw+p+1)=tempmp(rw,cw)
	  E(rw+M+2*p+1,cw+1)=tempmp(rw,cw)
536     continue
        do 537 cw=1,M
	  E(rw+M+2*p+1,cw+2*p+1)=tempmm(rw,cw)
537     continue
538   continue
      call multi4(M,N,N,N,ZT,nd2e2,tempmn)
      call multi5(M,N,N,p,tempmn,X,tempmp)
      call multi6(M,N,N,M,tempmn,Z,tempmm)
      do 543 rw=1,M
        do 541 cw=1,p
	  E(rw+M+2*p+1,cw+p+1)=tempmp(rw,cw)
541     continue
        do 542 cw=1,M
	  E(rw+M+2*p+1,cw+M+2*p+1)=tempmm(rw,cw)
542     continue
543   continue
      do 546 rw=1,1+2*p+2*M
	do 544 cw=rw,1+2*p+2*M
	  E(rw,cw)=E(cw,rw)
544     continue
546   continue
c   make matrix E and EINV: (1+2*p+2*M)*(1+2*p+2*M) matrix
      order2=1+2*p+2*M
      call add(order2,order2,E,D,E)
      call matinv(order2,E,EINV,ifault)
      if (ifault.ne.0) then
	write (25,*) 'ERROR in matinv: ifault = ',ifault
	do 613 l=1,order2
	  write (25,990) (E(l,k),k=1,order2)
613     continue
	stop
      endif
      goto 753
c   make first derivative matrices and A: (N*1) and (3N*1) matrix
      do 650 rw=1,N
        if (f(rw).eq.0.) then
	  A(rw)=0.
	  A(N+rw)=0.
	  A(2*N+rw)=0.
	  goto 650
	endif
	dx(rw)=(f1(rw)-f2(rw))*pi(rw)*(1.-pi(rw))/f(rw)
	de1(rw)=pi(rw)*f1(rw)*(Y(rw)-eta1(rw))/(f(rw)*sigsq1)
	de2(rw)=(1.-pi(rw))*f2(rw)*(Y(rw)-eta2(rw))/(f(rw)*sigsq2)
	A(rw)=dx(rw)
	A(N+rw)=de1(rw)
	A(2*N+rw)=de2(rw)
650   continue
c   make matrix B: (3p+3M)*1 matrix
      do 700 rw=1,order2
	B(rw)=0.
700   continue
      do 750 rw=1,M
	B(3*p+rw)=-v(rw)/lambda
	B(3*p+M+rw)=-u1(rw)/theta1
	B(3*p+2*M+rw)=-u2(rw)/theta2
750   continue
      call multi1(order2,order1,order1,1,CT,A,tempm3)
      call add1(order2,tempm3,B,tempm3)
      call add1(order2,EST,ESTNEW,ESTNEW)
753   finish=1
c770   write (25,*) iter,cter,(ESTNEW(l),l=1,1+2*p+2*M)
c      write (25,*) 'sigma: ',sigsq1,sigsq2,finish
      goto 797 
c   estimation of scale parameter
      temp1=0.
      temp2=0.
      do 780 l=1,N
	temp1=temp1+pi(l)*f1(l)*(Y(l)-eta1(l))**2/f(l)
	temp2=temp2+pi(l)*f1(l)/f(l)
780   continue
      finish=1
      if (abs(sigsq1-temp1/temp2).gt.tol) finish=0
      sigsq1=temp1/temp2
      temp1=0.
      temp2=0.
      do 790 l=1,N
	temp1=temp1+(1.-pi(l))*f2(l)*(Y(l)-eta2(l))**2/f(l)
	temp2=temp2+(1.-pi(l))*f2(l)/f(l)
790   continue
      if (abs(sigsq2-temp1/temp2).gt.tol) finish=0
      sigsq2=temp1/temp2
c      write (25,*) 'sigma: ',sigsq1,sigsq2,finish
c   convergence criterion for steps 1 and 2   
      if (finish.eq.0) then
        do 795 l=1,3*p+3*M
	  EST(l)=ESTNEW(l)
795     continue
        ind=2000*tol
	cter=0
        goto 303	
      endif
c   estimation of variance component
797   temp1=0.
      temp2=0.
      temp3=0.
      do 800 l=1,M
        temp1=temp1+EINV(1+2*p+l,1+2*p+l)+u1(l)**2
        temp2=temp2+EINV(1+2*p+M+l,1+2*p+M+l)+u2(l)**2
800   continue
      temp1=temp1/float(M)
      temp2=temp2/float(M)
      finish=1
      if (abs(temp1-theta1).gt.tol) finish=0
      if (abs(temp2-theta2).gt.tol) finish=0
      theta1=temp1
      theta2=temp2
c      write (25,*) 'lambda,theta1,theta2: ',theta1,theta2
c   convergence criterion for steps 1, 2, and 3   
      if (finish.eq.0) then
        do 805 l=1,1+2*p+2*M
	  EST(l)=ESTNEW(l)
805     continue
        ind=3000*tol
	cter=0
	print *,'estimation of variance component finished'
        goto 303	
      endif
      if (tol.ne.0.001) then
cc	write (25,*) 'fine tone: '
	tol=.001
        do 808 l=1,1+2*p+2*M
	  EST(l)=ESTNEW(l)
808     continue
	cter=0
        goto 303	
      endif
c   variance of gamma and beta
      varg(1)=EINV(1,1)
      do 810 l=1,p
        varb1(l)=EINV(1+l,1+l)
        varb2(l)=EINV(1+p+l,1+p+l)
810   continue
c   variance of lambda, theta1, and theta2
      temp1=0.
      temp2=0.
      temp3=0.
      do 815 l=1,M
        temp1=temp1+EINV(1+2*p+l,1+2*p+l)
	do 813 k=1,M
        temp2=temp2+EINV(1+2*p+l,1+2*p+k)*EINV(1+2*p+l,1+2*p+k)
        temp3=temp3+EINV(1+2*p+l,1+2*p+M+k)**2
813     continue
815   continue
      tempm4(1,1)=M-2.*temp1/theta1+theta1**(-2.)*temp2
      tempm4(1,1)=tempm4(1,1)*theta1**(-2.)
      tempm4(1,2)=theta1**(-2.)*theta2**(-2.)*temp3
      tempm4(2,1)=tempm4(1,2)
      temp1=0.
      temp2=0.
      temp3=0.
      do 820 l=1,M
        temp1=temp1+EINV(1+2*p+M+l,1+2*p+M+l)
	do 818 k=1,M
        temp2=temp2+EINV(1+2*p+M+l,1+2*p+M+k)**2
818     continue
820   continue
      tempm4(2,2)=M-2.*temp1/theta2+theta2**(-2.)*temp2
      tempm4(2,2)=tempm4(2,2)*theta2**(-2.)
      goto 831
      tempm4(2,2)=M-2.*temp1/theta1+theta1**(-2.)*temp2
      tempm4(2,2)=tempm4(2,2)*theta1**(-2.)
      temp1=0.
      temp2=0.
      temp3=0.
      do 830 l=1,M
	temp1=temp1+EINV(3*p+2*M+l,3*p+2*M+l)
	do 825 k=1,M
      temp2=temp2+EINV(3*p+2*M+l,3*p+2*M+k)*EINV(3*p+2*M+l,3*p+2*M+k)
	temp3=temp3+EINV(3*p+l,3*p+2*M+k)*EINV(3*p+l,3*p+2*M+k)
825     continue
830   continue
831   call matinv2(2,tempm4,tempm5,ifault)
      if (ifault.ne.0) then
        write (25,*) 'ERROR in matinv2: ifault = ',ifault
        do 833 l=1,2
          write (25,*) (tempm4(l,k),k=1,2)
833     continue
	stop
      endif
      write (25,*) 'FINAL EST: '
      write (25,*) 'mixing proportions: ', (1.-1./(exp(ESTNEW(1))+1.)), 
     +  (1./(exp(ESTNEW(1))+1.))
      write (25,*) '1st component: '
      write (25,*) 'log(lamda): ', ESTNEW(2)
      write (25,*) 'Beta: ', (ESTNEW(1+l),l=2,p)
      write (25,*) '2nd component: '
      write (25,*) 'log(lamda): ', ESTNEW(2+p)
      write (25,*) 'Beta: ', (ESTNEW(1+p+l),l=2,p)
      write (25,*) 'theta1, theta2, alpha1, alpha2: '
      write (25,*) theta1,theta2,sigsq1,sigsq2
      write (25,*) 'S.E. of beta: '
      write (25,*) '1st component: ', (sqrt(varb1(l)),l=1,p)
      write (25,*) '2nd component: ', (sqrt(varb2(l)),l=1,p)
      write (25,*) 'S.E. of variance components: '
      write (25,*) '1st component: ', sqrt(tempm5(1,1)*2.)
      write (25,*) '2nd component: ', sqrt(tempm5(2,2)*2.)
      write (25,*) 'predicted values u_1: '
      write (25,990) (ESTNEW(1+2*p+l),l=1,M)
      write (25,*) 'predicted values u_2: '
      write (25,990) (ESTNEW(1+2*p+M+l),l=1,M)
c      write (25,990) (sqrt(EINV(1+2*p+l,1+2*p+l)),l=1,2*M)
990   format(F15.9)
      stop
      end

      subroutine update(EST,ESTNEW,sigsq1,sigsq2)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer num   
      double precision EST(3*mp+3*mm),ESTNEW(3*mp+3*mm)
      double precision sigsq1,sigsq2
      common/comm1/X,Y,Z,tau,lambda,theta1,theta2,p,M,N,group
      integer p,M,N,group
      double precision X(mn,mp),Y(mn),Z(mn,mm),tau(2,mn)
      double precision lambda,theta1,theta2
      external evalbu,evalgv,HYBRD1
      integer sizehy,ifail
      double precision xhy(mp+mm+1),xtol,fvec(mp+mm+1),work(8700)

        ifail=0
        do 150 l=1,1   
          xhy(l)=EST(l)  
150     continue
        xtol=0.000000001
        num=1
        sizehy=3200
        call HYBRD1(evalgv,num,xhy,fvec,xtol,ifail,work,sizehy)
        if (ifail.ne.1) write (25,*) 'ifail for evalgv= ',ifail
        do 170 l=1,1
          ESTNEW(l)=xhy(l)
170     continue
      do 400 group=1,2
        ifail=0
        do 200 l=1,p   
          xhy(l)=EST(1+(group-1)*p+l)
200     continue
        do 220 l=1,M
          xhy(p+l)=EST(1+2*p+(group-1)*M+l)
220     continue
        xhy(p+M+1)=sigsq1
        if (group.eq.2) xhy(p+M+1)=sigsq2
        xtol=0.000000001
        sizehy=8700
        num=p+M+1
        call HYBRD1(evalbu,num,xhy,fvec,xtol,ifail,work,sizehy)
        if (ifail.ne.1) write (25,*) 'ifail for evalbu= ',ifail
        do 300 l=1,p
          ESTNEW(1+(group-1)*p+l)=xhy(l)
300     continue
        do 320 l=1,M
          ESTNEW(1+2*p+(group-1)*M+l)=xhy(p+l)
320     continue
        if (group.eq.1) sigsq1=xhy(p+M+1)
        if (group.eq.2) sigsq2=xhy(p+M+1)
400   continue
      return
      end

      subroutine evalgv(ne,xhy,fvec,iflag)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer ne,iflag
      double precision xhy(*),fvec(*),tmp(mp+mm+1),temp,xi,pi
      common/comm1/X,Y,Z,tau,lambda,theta1,theta2,p,M,N,group
      integer p,M,N,group
      double precision X(mn,mp),Y(mn),Z(mn,mm),tau(2,mn)
      double precision lambda,theta1,theta2
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=xhy(l)
        fvec(l)=0.
50    continue
      do 300 j=1,n
        xi=0.
        xi=xi+tmp(1)*X(j,1)
        pi=exp(xi)/(1.+exp(xi))
        do 200 l=1,1
	  temp=tau(1,j)-pi
          fvec(l)=fvec(l)+temp*X(j,l)
200     continue
300   continue
      return
      end

      subroutine evalbu(ne,xhy,fvec,iflag)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer ne,iflag
      double precision xhy(*),fvec(*),tmp(mp+mm+1),temp,eta
      double precision h,logs
      common/comm1/X,Y,Z,tau,lambda,theta1,theta2,p,M,N,group
      integer p,M,N,group
      double precision X(mn,mp),Y(mn),Z(mn,mm),tau(2,mn)
      double precision lambda,theta1,theta2
      common/comm2/CEN
      integer CEN(mn)
      intrinsic exp,log

      do 50 l=1,ne
        tmp(l)=xhy(l)
        fvec(l)=0.
50    continue
      do 300 j=1,N
        eta=0.
        do 100 l=1,p
          eta=eta+tmp(l)*X(j,l)
100     continue
        do 150 l=1,M
          eta=eta+tmp(p+l)*Z(j,l)
150     continue
   	h=exp(eta)*tmp(ne)*Y(j)**(tmp(ne)-1.)
   	logs=-Y(j)**tmp(ne)*exp(eta)
        do 200 l=1,p
          fvec(l)=fvec(l)+tau(group,j)*(CEN(j)+logs)*X(j,l)
200     continue
        do 250 l=1,M
          temp=tau(group,j)*Z(j,l)*(CEN(j)+logs)
          if (group.eq.1) fvec(p+l)=fvec(p+l)+temp-
     +	  tmp(p+l)/(theta1*n)
          if (group.eq.2) fvec(p+l)=fvec(p+l)+temp-
     +	  tmp(p+l)/(theta2*n)
250     continue
        temp=CEN(j)*(1.+tmp(ne)*log(Y(j)))-h*Y(j)*log(Y(j))
        fvec(p+M+1)=fvec(p+M+1)+tau(group,j)*temp
300   continue
      return
      end

      subroutine trans1(nr,nc,mat1,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr,nc,rw,cn
      double precision mat1(mn,mp)
      double precision newmat(mp,mn)

      do 200 rw=1,nc
	do 100 cn=1,nr
	  newmat(rw,cn)=mat1(cn,rw)
100     continue
200   continue
      return
      end
      
      subroutine trans2(nr,nc,mat1,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr,nc,rw,cn
      double precision mat1(mn,mm)
      double precision newmat(mm,mn)

      do 200 rw=1,nc
	do 100 cn=1,nr
	  newmat(rw,cn)=mat1(cn,rw)
100     continue
200   continue
      return
      end

      subroutine munp1(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mn,mp),mat2(mp),newmat(mn)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	  newmat(rw)=0.
	  do 50 l=1,nc1
	    newmat(rw)=newmat(rw)+mat1(rw,l)*mat2(l)
50        continue
200   continue
      return
      end

      subroutine mupn1(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mp,mn),mat2(mn),newmat(mp)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	  newmat(rw)=0.
	  do 50 l=1,nc1
	    newmat(rw)=newmat(rw)+mat1(rw,l)*mat2(l)
50        continue
200   continue
      return
      end
      
      subroutine munm1(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mn,mm),mat2(mm),newmat(mn)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	  newmat(rw)=0.
	  do 50 l=1,nc1
	    newmat(rw)=newmat(rw)+mat1(rw,l)*mat2(l)
50        continue
200   continue
      return
      end
      
      subroutine mumn1(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mm,mn),mat2(mn),newmat(mm)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	  newmat(rw)=0.
	  do 50 l=1,nc1
	    newmat(rw)=newmat(rw)+mat1(rw,l)*mat2(l)
50        continue
200   continue
      return
      end
      
      subroutine multi1(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(3*mp+3*mm,3*mn),mat2(3*mn)
      double precision newmat(3*mp+3*mm)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	  newmat(rw)=0.
	  do 50 l=1,nc1
	    newmat(rw)=newmat(rw)+mat1(rw,l)*mat2(l)
50        continue
200   continue
      return
      end

      subroutine multi2(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mp,mn),mat2(mn,mn)
      double precision newmat(mp,mn)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+mat1(rw,l)*mat2(l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multi3(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mp,mn)
      double precision mat2(mn,mp)
      double precision newmat(mp,mp)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+mat1(rw,l)*mat2(l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multi4(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mm,mn)
      double precision mat2(mn,mn)
      double precision newmat(mm,mn)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+mat1(rw,l)*mat2(l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multi5(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mm,mn)
      double precision mat2(mn,mp)
      double precision newmat(mm,mp)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+mat1(rw,l)*mat2(l,cn)
50        continue
100     continue
200   continue
      return
      end

      subroutine multi6(nr1,nc1,nr2,nc2,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr1,nc1,nr2,nc2,rw,cn
      double precision mat1(mm,mn)
      double precision mat2(mn,mm)
      double precision newmat(mm,mm)

      if (nc1.ne.nr2) then
	write (25,*) 'ERROR in multiplication of matrices.'
	stop
      endif
      do 200 rw=1,nr1
	do 100 cn=1,nc2
	  newmat(rw,cn)=0.
	  do 50 l=1,nc1
	    newmat(rw,cn)=newmat(rw,cn)+mat1(rw,l)*mat2(l,cn)
50        continue
100     continue
200   continue
      return
      end
      
      subroutine add(nr,nc,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr,nc,rw,cn
      double precision mat1(3*mp+3*mm,3*mp+3*mm)
      double precision mat2(3*mp+3*mm,3*mp+3*mm)
      double precision newmat(3*mp+3*mm,3*mp+3*mm)

      do 200 rw=1,nr
	do 100 cn=1,nc
	  newmat(rw,cn)=mat1(rw,cn)+mat2(rw,cn)
100     continue
200   continue
      return
      end
      
      subroutine add1(nr,mat1,mat2,newmat)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nr,rw
      double precision mat1(3*mp+3*mm),mat2(3*mp+3*mm)
      double precision newmat(3*mp+3*mm)

      do 200 rw=1,nr
        newmat(rw)=mat1(rw)+mat2(rw)
200   continue
      return
      end
      
      subroutine matinv(nv,mat1,mat2,ierr)
      parameter(mm=167)
      parameter(mp=20)
      parameter(mn=700)
      parameter(mni=200)
      integer nv,rw,cn,ctr,nullty,ifault,ierr
      double precision mat1(3*mp+3*mm,3*mp+3*mm)
      double precision mat2(3*mp+3*mm,3*mp+3*mm)
      double precision arr1((3*mp+3*mm)*(3*mp+3*mm+1))
      double precision arr2((3*mp+3*mm)*(3*mp+3*mm+1))
      double precision cmy((3*mp+3*mm)*(3*mp+3*mm+1)),work(3*mp+3*mm)
      integer IP(3*mp+3*mm)
      double precision E(3*mp+3*mm,3*mp+3*mm+1)
                       
      DO 100 MI=1,nv
        DO 50 MJ=1,MI
          E(MI,MJ)=mat1(MI,MJ)
          E(MJ,MI)=E(MI,MJ)
50      CONTINUE
100   CONTINUE
      TOL=0.000001
      IERR=0
      DO 200 MI=1,nv
        IP(MI)=MI
200   CONTINUE
      DO 650 L=1,nv
C   Search for pivot
        IR=L 
        EMAX=0.0
        DO 250 MI=L,nv
          IF (ABS(E(MI,L)).LE.ABS(EMAX)) GOTO 250
          EMAX=E(MI,L)
          IR=MI
250     CONTINUE
C   Record pivot row
        MI=IP(L)
        IP(L)=IP(IR)
        IP(IR)=MI
C   Test for zero pivot
        IF (EMAX.NE.0) GOTO 300
        IERR=1
        RETURN
C   Move selected pivot row to pivot row
300     IF (IR.EQ.L) GOTO 400
        DO 350 MJ=1,nv
          TEMP=E(IR,MJ)
          E(IR,MJ)=E(L,MJ)
          E(L,MJ)=TEMP
350     CONTINUE
C   Transform matrix
400     DO 450 MJ=1,nv
          E(L,MJ)=E(L,MJ)/EMAX
450     CONTINUE
        DO 550 MI=1,nv
          IF (MI.EQ.L) GOTO 550
          DO 500 MJ=1,nv
            IF (MJ.EQ.L) GOTO 500
            T1=E(MI,MJ)
            T2=E(MI,L)*E(L,MJ)
            T3=T1-T2
            IF (ABS(T3).LT.(ABS(T1)+ABS(T2))*TOL) T3=0.0
            E(MI,MJ)=T3
500       CONTINUE
550     CONTINUE
        DO 600 MI=1,nv
          E(MI,L)=-E(MI,L)/EMAX
600     CONTINUE
        E(L,L)=1.0/EMAX
650   CONTINUE
C   Realign inverse
      DO 850 L=1,nv
        DO 700 MJ=1,nv
          IF (L.EQ.IP(MJ)) GOTO 750
700     CONTINUE
750     IF (MJ.EQ.L) GOTO 850
        DO 800 MI=1,nv
          TEMP=E(MI,MJ)
          E(MI,MJ)=E(MI,L)
          E(MI,L)=TEMP
800     CONTINUE
          MI=IP(L)
          IP(L)=IP(MJ)
          IP(MJ)=MI
850   CONTINUE
      IF (IERR.EQ.1) IERR=3
      IF (IERR.EQ.2) IERR=0
      IF (IERR.NE.0) RETURN
      DO 890 MI=1,nv
        DO 870 MJ=1,MI
          mat2(MI,MJ)=E(MI,MJ)
          mat2(MJ,MI)=mat2(MI,MJ)
870     CONTINUE
890   CONTINUE
      RETURN
      END

      subroutine matinv2(nv,mat1,mat2,ierr)
      integer nv,rw,cn,ctr,nullty,ifault,ierr
      double precision mat1(2,2),mat2(2,2),arr1(2*3),arr2(2*3)
      double precision cmy(2*3),work(2)
      integer IP(2)
      double precision E(2,3)
                       
      DO 100 MI=1,nv
        DO 50 MJ=1,MI
          E(MI,MJ)=mat1(MI,MJ)
          E(MJ,MI)=E(MI,MJ)
50      CONTINUE
100   CONTINUE
      TOL=0.000001
      IERR=0
      DO 200 MI=1,nv
        IP(MI)=MI
200   CONTINUE
      DO 650 L=1,nv
C   Search for pivot
        IR=L 
        EMAX=0.0
        DO 250 MI=L,nv
          IF (ABS(E(MI,L)).LE.ABS(EMAX)) GOTO 250
          EMAX=E(MI,L)
          IR=MI
250     CONTINUE
C   Record pivot row
        MI=IP(L)
        IP(L)=IP(IR)
        IP(IR)=MI
C   Test for zero pivot
        IF (EMAX.NE.0) GOTO 300
        IERR=1
        RETURN
C   Move selected pivot row to pivot row
300     IF (IR.EQ.L) GOTO 400
        DO 350 MJ=1,nv
          TEMP=E(IR,MJ)
          E(IR,MJ)=E(L,MJ)
          E(L,MJ)=TEMP
350     CONTINUE
C   Transform matrix
400     DO 450 MJ=1,nv
          E(L,MJ)=E(L,MJ)/EMAX
450     CONTINUE
        DO 550 MI=1,nv
          IF (MI.EQ.L) GOTO 550
          DO 500 MJ=1,nv
            IF (MJ.EQ.L) GOTO 500
            T1=E(MI,MJ)
            T2=E(MI,L)*E(L,MJ)
            T3=T1-T2
            IF (ABS(T3).LT.(ABS(T1)+ABS(T2))*TOL) T3=0.0
            E(MI,MJ)=T3
500       CONTINUE
550     CONTINUE
        DO 600 MI=1,nv
          E(MI,L)=-E(MI,L)/EMAX
600     CONTINUE
        E(L,L)=1.0/EMAX
650   CONTINUE
C   Realign inverse
      DO 850 L=1,nv
        DO 700 MJ=1,nv
          IF (L.EQ.IP(MJ)) GOTO 750
700     CONTINUE
750     IF (MJ.EQ.L) GOTO 850
        DO 800 MI=1,nv
          TEMP=E(MI,MJ)
          E(MI,MJ)=E(MI,L)
          E(MI,L)=TEMP
800     CONTINUE
          MI=IP(L)
          IP(L)=IP(MJ)
          IP(MJ)=MI
850   CONTINUE
      IF (IERR.EQ.1) IERR=3
      IF (IERR.EQ.2) IERR=0
      IF (IERR.NE.0) RETURN
      DO 890 MI=1,nv
        DO 870 MJ=1,MI
          mat2(MI,MJ)=E(MI,MJ)
          mat2(MJ,MI)=mat2(MI,MJ)
870     CONTINUE
890   CONTINUE
      RETURN
      END

